var vialState;
(function (vialState) {
    vialState[vialState["red"] = 0] = "red";
    vialState[vialState["green"] = 1] = "green";
    vialState[vialState["blue"] = 2] = "blue";
    vialState[vialState["hRed"] = 3] = "hRed";
    vialState[vialState["hGreen"] = 4] = "hGreen";
    vialState[vialState["hBlue"] = 5] = "hBlue";
    vialState[vialState["hRedResult"] = 6] = "hRedResult";
    vialState[vialState["hGreenResult"] = 7] = "hGreenResult";
    vialState[vialState["hBlueResult"] = 8] = "hBlueResult";
    vialState[vialState["yellow"] = 9] = "yellow";
    vialState[vialState["cyan"] = 10] = "cyan";
    vialState[vialState["magenta"] = 11] = "magenta";
    vialState[vialState["empty"] = 12] = "empty";
    vialState[vialState["emptyUnusable"] = 13] = "emptyUnusable";
    vialState[vialState["invisible"] = 14] = "invisible";
})(vialState || (vialState = {}));
;
var GGJ16;
(function (GGJ16) {
    var DataManager = (function () {
        //
        // NOTE: Constructor
        //
        function DataManager() {
            if (DataManager._instance) {
                throw new Error("Error: Instantiation failed: Use SingletonDemo.getInstance() instead of new.");
            }
            DataManager._instance = this;
            this.initValues();
        }
        //
        // NOTE: Init Values
        //
        DataManager.prototype.initValues = function () {
            this.canClick = true;
            this.shouldShowInitialMessages = true;
            //
            // NOTE: Inventory
            //
            this.piece1 = false;
            this.piece2 = false;
            this.piece3 = false;
            this.vialY = false;
            this.vialC = false;
            this.vialM = false;
            this.ruby = false;
            this.keyDrawer = false;
            this.note = false;
            this.notePlaced = false;
            //
            // NOTE: Puzzle1
            //
            this.topDrawerDone = false;
            this.topDrawerOpen = false;
            this.bottomDrawerDone = false;
            this.bottomDrawerOpen = false;
            this.skullDone = false;
            this.skullMouthOpen = false;
            //
            // NOTE: Puzzle2 
            //
            this.vialRStatus = vialState.red;
            this.vialGStatus = vialState.green;
            this.vialBStatus = vialState.blue;
            this.vialYStatus = vialState.empty;
            this.vialCStatus = vialState.empty;
            this.vialMStatus = vialState.empty;
            this.vial1Presence = true;
            this.vial2Presence = true;
            this.vial3Presence = true;
            this.vial1Status = vialState.empty;
            this.vial2Status = vialState.empty;
            this.vial3Status = vialState.empty;
            //
            // NOTE: Puzzle3
            //
            this.vial1Placement = false;
            this.vial2Placement = false;
            this.vial3Placement = false;
            this.puzzle3Done = false;
            //
            // NOTE: Puzzle4
            //
            this.lockerOpen = false;
            this.lockerDone = false;
            this.showPieceMonologue = false;
            //
            // NOTE: Puzzle5
            //
            this.piece1Placed = false;
            this.piece2Placed = false;
            this.piece3Placed = false;
        };
        DataManager.getInstance = function () {
            return DataManager._instance;
        };
        DataManager._instance = new DataManager();
        return DataManager;
    })();
    GGJ16.DataManager = DataManager;
})(GGJ16 || (GGJ16 = {}));
/// <reference path="../tsDefinitions/phaser.d.ts" />
/// <reference path="./DataManager.ts" />
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var GGJ16;
(function (GGJ16) {
    var IntroMessage = (function (_super) {
        __extends(IntroMessage, _super);
        function IntroMessage(g, message) {
            this.g = g;
            _super.call(this, this.g, 0, 0, message);
            var style = { font: "24px Arial", fill: "#ffffff", align: "center" };
            this.setStyle(style);
            this.position.set(this.g.world.centerX, this.g.world.height - 40);
            this.anchor.set(0.5);
            this.alpha = 0.0;
            this.animate();
            this.g.add.existing(this);
        }
        IntroMessage.prototype.animate = function () {
            var _this = this;
            var fadeOut;
            var fadeIn = this.g.add.tween(this).to({ alpha: 1.0 }, 2500, Phaser.Easing.Linear.None, true);
            fadeIn.onComplete.add(function () {
                fadeOut = _this.g.add.tween(_this).to({ alpha: 0.0 }, 1000, Phaser.Easing.Linear.None, true, 5000);
                fadeOut.onComplete.add(function () {
                    GGJ16.DataManager.getInstance().canClick = true;
                    GGJ16.DataManager.getInstance().shouldShowInitialMessages = false;
                    _this.destroy();
                });
            }, this);
        };
        return IntroMessage;
    })(Phaser.Text);
    GGJ16.IntroMessage = IntroMessage;
})(GGJ16 || (GGJ16 = {}));
/// <reference path="../tsDefinitions/phaser.d.ts" />
/// <reference path="./DataManager.ts" />
var GGJ16;
(function (GGJ16) {
    var Inventory = (function () {
        function Inventory(g) {
            this.g = g;
            this.arrayItems = new Array();
            this.fillInventory();
            this.drawInventory();
        }
        Inventory.prototype.fillInventory = function () {
            var _this = this;
            //Ruby
            if (GGJ16.DataManager.getInstance().ruby)
                this.arrayItems.push(new Phaser.Sprite(this.g, 0, 0, 'ruby'));
            //Key
            if (GGJ16.DataManager.getInstance().keyDrawer)
                this.arrayItems.push(new Phaser.Sprite(this.g, 0, 0, 'key'));
            //Piece1
            if (GGJ16.DataManager.getInstance().piece1)
                this.arrayItems.push(new Phaser.Sprite(this.g, 0, 0, 'piece1puzzle64'));
            //Piece2
            if (GGJ16.DataManager.getInstance().piece2)
                this.arrayItems.push(new Phaser.Sprite(this.g, 0, 0, 'piece2puzzle64'));
            //Piece3
            if (GGJ16.DataManager.getInstance().piece3)
                this.arrayItems.push(new Phaser.Sprite(this.g, 0, 0, 'piece3puzzle64'));
            //VialY
            if (GGJ16.DataManager.getInstance().vialY)
                this.arrayItems.push(new Phaser.Sprite(this.g, 0, 0, 'vialYellowFull'));
            //VialC
            if (GGJ16.DataManager.getInstance().vialC)
                this.arrayItems.push(new Phaser.Sprite(this.g, 0, 0, 'vialCyanFull'));
            //VialBr
            if (GGJ16.DataManager.getInstance().vialM)
                this.arrayItems.push(new Phaser.Sprite(this.g, 0, 0, 'vialMagentaFull'));
            //Hint
            if (GGJ16.DataManager.getInstance().note)
                this.arrayItems.push(new Phaser.Sprite(this.g, 0, 0, 'note'));
            this.arrayItems.forEach(function (element) {
                element.inputEnabled = true;
                element.events.onInputDown.add(_this.clickedInventoryItem, _this);
            });
        };
        Inventory.prototype.clickedInventoryItem = function () {
            new GGJ16.Monologue(this.g, "< You don't need to click an item in order to use it >");
        };
        Inventory.prototype.drawInventory = function () {
            var _this = this;
            var count = 1;
            var offsetX = 40;
            var offsetY = 10;
            this.arrayItems.forEach(function (element) {
                element.position.set(offsetX + (element.width * count), offsetY + element.height / 2);
                element.anchor.set(0.5);
                _this.g.add.existing(element);
                count++;
            });
        };
        Inventory.prototype.tick = function () {
            this.arrayItems.forEach(function (element) {
                element.destroy();
            });
            this.arrayItems = new Array();
            this.fillInventory();
            this.drawInventory();
        };
        return Inventory;
    })();
    GGJ16.Inventory = Inventory;
})(GGJ16 || (GGJ16 = {}));
/// <reference path="../tsDefinitions/phaser.d.ts" />
var GGJ16;
(function (GGJ16) {
    var Main = (function (_super) {
        __extends(Main, _super);
        function Main() {
            _super.call(this, 1200, 760, Phaser.AUTO, 'content', null);
            this.state.add('Boot', GGJ16.Boot, false);
            this.state.add('Preload', GGJ16.Preload, false);
            this.state.add('Puzzle3', GGJ16.Puzzle3, false);
            this.state.add('Puzzle4', GGJ16.Puzzle4, false);
            this.state.add('Puzzle5', GGJ16.Puzzle5, false);
            this.state.add('MainMenu', GGJ16.MainMenu, false);
            this.state.add('Credits', GGJ16.Credits, false);
            this.state.add('Room1', GGJ16.Room1, false);
            this.state.add('Room2', GGJ16.Room2, false);
            this.state.add('Room3', GGJ16.Room3, false);
            this.state.add('Intro', GGJ16.Intro, false);
            this.state.add('Outro', GGJ16.Outro, false);
            this.state.start('Boot');
        }
        return Main;
    })(Phaser.Game);
    GGJ16.Main = Main;
})(GGJ16 || (GGJ16 = {}));
window.onload = function () {
    var game = new GGJ16.Main();
};
/// <reference path="../tsDefinitions/phaser.d.ts" />
/// <reference path="./DataManager.ts" />
var GGJ16;
(function (GGJ16) {
    var Monologue = (function (_super) {
        __extends(Monologue, _super);
        function Monologue(g, message) {
            this.g = g;
            _super.call(this, this.g, 0, 0, message);
            var style = { font: "24px Arial", fill: "#ffffff", align: "center" };
            this.setStyle(style);
            this.position.set(this.g.world.centerX, this.g.world.height - 40);
            this.anchor.set(0.5);
            this.alpha = 0.0;
            this.animate();
            this.g.add.existing(this);
        }
        Monologue.prototype.animate = function () {
            var _this = this;
            var fadeOut;
            var fadeIn = this.g.add.tween(this).to({ alpha: 1.0 }, 500, Phaser.Easing.Linear.None, true);
            fadeIn.onComplete.add(function () {
                fadeOut = _this.g.add.tween(_this).to({ alpha: 0.0 }, 2500, Phaser.Easing.Linear.None, true, 250);
                fadeOut.onComplete.add(function () { _this.destroy(); });
            }, this);
        };
        return Monologue;
    })(Phaser.Text);
    GGJ16.Monologue = Monologue;
})(GGJ16 || (GGJ16 = {}));
/// <reference path="../tsDefinitions/phaser.d.ts" />
var GGJ16;
(function (GGJ16) {
    var Puzzle4Button = (function (_super) {
        __extends(Puzzle4Button, _super);
        function Puzzle4Button(p4, identifier, x, y, idx) {
            _super.call(this, p4.game, x, y, identifier);
            this.alpha = 0.6;
            this.anchor.set(0.5);
            p4.game.add.existing(this);
            this.idx = idx;
            this.inputEnabled = true;
            this.p4 = p4;
            this.events.onInputDown.add(this.handleClick, this);
            this.events.onInputOver.add(this.handleOver, this);
            this.events.onInputOut.add(this.handleOut, this);
            this.state = 0;
        }
        Puzzle4Button.prototype.handleOver = function () {
            this.alpha = 1.0;
        };
        Puzzle4Button.prototype.handleOut = function () {
            this.alpha = 0.6;
        };
        Puzzle4Button.prototype.handleClick = function () {
            if (!GGJ16.DataManager.getInstance().canClick) {
                return;
            }
            if (!GGJ16.DataManager.getInstance().puzzle3Done) {
                new GGJ16.Monologue(this.game, "Even if I tried, I wouldn't know what to do... yet...");
                return;
            }
            if (Number(this.idx) == Number(this.p4.nextIdx)) {
                // this.p3.sfxPressButton.play();
                this.p4.countProgress = Number(this.p4.countProgress) + 1;
                this.state = 1;
                this.loadTexture('dbtn');
                this.p4.nextIdx = this.p4.sequence[this.p4.countProgress];
                this.p4.sfxGrab.play();
                if (this.p4.countProgress == this.p4.sequence.length) {
                    GGJ16.DataManager.getInstance().lockerOpen = true;
                }
            }
            else {
                this.p4.resetButtons();
                this.p4.sfxGrab.play();
            }
        };
        return Puzzle4Button;
    })(Phaser.Sprite);
    GGJ16.Puzzle4Button = Puzzle4Button;
})(GGJ16 || (GGJ16 = {}));
/// <reference path="../tsDefinitions/phaser.d.ts" />
var GGJ16;
(function (GGJ16) {
    var Puzzle5Piece = (function (_super) {
        __extends(Puzzle5Piece, _super);
        function Puzzle5Piece(p5, identifier, x, y, xidx, yidx) {
            _super.call(this, p5.game, x, y, identifier);
            this.alpha = 0.7;
            this.anchor.set(0.5);
            p5.game.add.existing(this);
            this.xidx = xidx;
            this.yidx = yidx;
            this.inputEnabled = true;
            this.p5 = p5;
            this.events.onInputDown.add(this.handleClick, this);
            this.events.onInputOver.add(this.handleOver, this);
            this.events.onInputOut.add(this.handleOut, this);
            this.slideTime = 280;
        }
        Puzzle5Piece.prototype.iAmHere = function (xidx, yidx) {
            if (Number(this.xidx) === Number(xidx) && Number(this.yidx) == Number(yidx))
                return true;
            return false;
        };
        Puzzle5Piece.prototype.handleOver = function () {
            if (GGJ16.DataManager.getInstance().piece1Placed && GGJ16.DataManager.getInstance().piece2Placed && GGJ16.DataManager.getInstance().piece3Placed)
                this.alpha = 1.0;
        };
        Puzzle5Piece.prototype.handleOut = function () {
            if (GGJ16.DataManager.getInstance().piece1Placed && GGJ16.DataManager.getInstance().piece2Placed && GGJ16.DataManager.getInstance().piece3Placed)
                this.alpha = 0.7;
        };
        Puzzle5Piece.prototype.handleClick = function () {
            if (this.p5.minigameCanRun && !this.p5.pieceMoving) {
                var pieces = this.p5.pieces;
                var canMove = true;
                var nx = Number(this.xidx);
                var ny = Number(this.yidx);
                if (nx - 1 >= 0) {
                    pieces.forEach(function (piece) {
                        if (piece.iAmHere(nx - 1, ny))
                            canMove = false;
                    });
                    if (canMove) {
                        this.p5.pieceMoving = true;
                        this.p5.game.add.tween(this).to({ x: (this.x - this.p5.numPieceDimensions) }, this.slideTime, Phaser.Easing.Linear.None, true).onComplete.add(this.releaseGame, this);
                        this.xidx = Number(this.xidx) - 1;
                        this.p5.sfxMovePiece.play();
                        return;
                    }
                }
                canMove = true;
                if (nx + 1 <= 2) {
                    pieces.forEach(function (piece) {
                        if (piece.iAmHere(nx + 1, ny))
                            canMove = false;
                    });
                    if (canMove) {
                        this.p5.pieceMoving = true;
                        this.p5.game.add.tween(this).to({ x: (this.x + this.p5.numPieceDimensions) }, this.slideTime, Phaser.Easing.Linear.None, true).onComplete.add(this.releaseGame, this);
                        this.xidx = Number(this.xidx) + 1;
                        this.p5.sfxMovePiece.play();
                        return;
                    }
                }
                canMove = true;
                if (ny - 1 >= 0) {
                    pieces.forEach(function (piece) {
                        if (piece.iAmHere(nx, ny - 1))
                            canMove = false;
                    });
                    if (canMove) {
                        this.p5.pieceMoving = true;
                        this.p5.game.add.tween(this).to({ y: (this.y - this.p5.numPieceDimensions) }, this.slideTime, Phaser.Easing.Linear.None, true).onComplete.add(this.releaseGame, this);
                        this.yidx = Number(this.yidx) - 1;
                        this.p5.sfxMovePiece.play();
                        return;
                    }
                }
                canMove = true;
                if (ny + 1 <= 2) {
                    pieces.forEach(function (piece) {
                        if (piece.iAmHere(nx, ny + 1))
                            canMove = false;
                    });
                    if (canMove) {
                        this.p5.pieceMoving = true;
                        this.p5.game.add.tween(this).to({ y: (this.y + this.p5.numPieceDimensions) }, this.slideTime, Phaser.Easing.Linear.None, true).onComplete.add(this.releaseGame, this);
                        this.yidx = Number(this.yidx) + 1;
                        this.p5.sfxMovePiece.play();
                        return;
                    }
                }
            }
        };
        Puzzle5Piece.prototype.releaseGame = function () {
            this.p5.pieceMoving = false;
        };
        return Puzzle5Piece;
    })(Phaser.Sprite);
    GGJ16.Puzzle5Piece = Puzzle5Piece;
})(GGJ16 || (GGJ16 = {}));
/// <reference path="../tsDefinitions/phaser.d.ts" />
/// <reference path="./DataManager.ts" />
var GGJ16;
(function (GGJ16) {
    var Vial = (function (_super) {
        __extends(Vial, _super);
        function Vial(g, x, y, type, id) {
            this.animating = false;
            this.colorState = type;
            this.id = id;
            switch (type) {
                case vialState.red:
                    if (GGJ16.DataManager.getInstance().vialRStatus == vialState.red) {
                        _super.call(this, g, x, y, 'vialRedFull');
                    }
                    else if (GGJ16.DataManager.getInstance().vialRStatus == vialState.hRed) {
                        _super.call(this, g, x, y, 'vialRedHalf');
                        this.colorState = GGJ16.DataManager.getInstance().vialRStatus;
                    }
                    else {
                        _super.call(this, g, x, y, 'vialEmpty');
                        this.colorState = vialState.emptyUnusable;
                    }
                    break;
                case vialState.green:
                    if (GGJ16.DataManager.getInstance().vialGStatus == vialState.green) {
                        _super.call(this, g, x, y, 'vialGreenFull');
                    }
                    else if (GGJ16.DataManager.getInstance().vialGStatus == vialState.hGreen) {
                        _super.call(this, g, x, y, 'vialGreenHalf');
                        this.colorState = GGJ16.DataManager.getInstance().vialGStatus;
                    }
                    else {
                        _super.call(this, g, x, y, 'vialEmpty');
                        this.colorState = vialState.emptyUnusable;
                    }
                    break;
                case vialState.blue:
                    if (GGJ16.DataManager.getInstance().vialBStatus == vialState.blue) {
                        _super.call(this, g, x, y, 'vialBlueFull');
                    }
                    else if (GGJ16.DataManager.getInstance().vialBStatus == vialState.hBlue) {
                        _super.call(this, g, x, y, 'vialBlueHalf');
                        this.colorState = GGJ16.DataManager.getInstance().vialBStatus;
                    }
                    else {
                        _super.call(this, g, x, y, 'vialEmpty');
                        this.colorState = vialState.emptyUnusable;
                    }
                    break;
                default:
                    _super.call(this, g, x, y, 'vialEmpty');
                    this.colorState = vialState.emptyUnusable;
                    break;
            }
            this.g = g;
            this.anchor.x = 0.5;
            this.anchor.y = 0.5;
            this.inputEnabled = true;
            g.add.existing(this);
            // this.emitter = g.game.add.emitter(x + ptm/2, y + ptm/2);
            // this.emitter.makeParticles('ministar', 1, 20, false);
            if (this.id === 1 && !GGJ16.DataManager.getInstance().vial1Presence ||
                this.id === 2 && !GGJ16.DataManager.getInstance().vial2Presence ||
                this.id === 3 && !GGJ16.DataManager.getInstance().vial3Presence) {
                this.colorState = vialState.invisible;
                this.inputEnabled = false;
                this.alpha = 0.0;
            }
            else if (this.id === 1) {
                this.colorState = GGJ16.DataManager.getInstance().vial1Status;
            }
            else if (this.id === 2) {
                this.colorState = GGJ16.DataManager.getInstance().vial2Status;
            }
            else if (this.id === 3) {
                this.colorState = GGJ16.DataManager.getInstance().vial3Status;
            }
            switch (this.colorState) {
                case vialState.hRedResult:
                    this.loadTexture('vialRedHalf');
                    break;
                case vialState.hGreenResult:
                    this.loadTexture('vialGreenHalf');
                    break;
                case vialState.hBlueResult:
                    this.loadTexture('vialBlueHalf');
                    break;
            }
            console.log("Created vial " + this.id);
        }
        Vial.prototype.setNewColor = function (color) {
            switch (color) {
                case vialState.red:
                case vialState.hRed:
                    this.loadTexture('vialRedHalf');
                    this.colorState = vialState.hRedResult;
                    // DataManager.getInstance().vialRStatus = this.colorState;
                    break;
                case vialState.green:
                case vialState.hGreen:
                    this.loadTexture('vialGreenHalf');
                    this.colorState = vialState.hGreenResult;
                    // DataManager.getInstance().vialGStatus = this.colorState;
                    break;
                case vialState.blue:
                case vialState.hBlue:
                    this.loadTexture('vialBlueHalf');
                    this.colorState = vialState.hBlueResult;
                    // DataManager.getInstance().vialBStatus = this.colorState;
                    break;
            }
            switch (this.id) {
                case 1:
                    GGJ16.DataManager.getInstance().vial1Status = this.colorState;
                    break;
                case 2:
                    GGJ16.DataManager.getInstance().vial2Status = this.colorState;
                    break;
                case 3:
                    GGJ16.DataManager.getInstance().vial3Status = this.colorState;
                    break;
            }
        };
        Vial.prototype.mixColor = function (color) {
            var _this = this;
            switch (color) {
                case vialState.red:
                case vialState.hRed:
                    switch (this.colorState) {
                        case vialState.hGreenResult:
                            if (GGJ16.DataManager.getInstance().vialY) {
                                new GGJ16.Monologue(this.game, "I already got an Yellow Vial...");
                                return false;
                            }
                            this.loadTexture('vialYellowFull');
                            this.colorState = vialState.yellow;
                            new GGJ16.Monologue(this.game, "I got an Yellow Vial...");
                            GGJ16.DataManager.getInstance().canClick = false;
                            var tween = this.game.add.tween(this).to({ x: [0, this.width + 10], y: [this.position.y, 10] }, 500, "Sine.easeInOut", true, 0, 0, false);
                            tween.interpolation(Phaser.Math.bezierInterpolation);
                            tween.onComplete.add(function () {
                                GGJ16.DataManager.getInstance().canClick = true;
                                GGJ16.DataManager.getInstance().vialY = true;
                                _this.alpha = 0.0;
                            });
                            // DataManager.getInstance().vialY = true;
                            break;
                        case vialState.hBlueResult:
                            if (GGJ16.DataManager.getInstance().vialM) {
                                new GGJ16.Monologue(this.game, "I already got a Magenta Vial...");
                                return false;
                            }
                            this.loadTexture('vialMagentaFull');
                            this.colorState = vialState.magenta;
                            // DataManager.getInstance().vialM = true;
                            new GGJ16.Monologue(this.game, "I got a Magenta Vial...");
                            GGJ16.DataManager.getInstance().canClick = false;
                            var tween = this.game.add.tween(this).to({ x: [0, this.width + 10], y: [this.position.y, 10] }, 500, "Sine.easeInOut", true, 0, 0, false);
                            tween.interpolation(Phaser.Math.bezierInterpolation);
                            tween.onComplete.add(function () {
                                GGJ16.DataManager.getInstance().canClick = true;
                                GGJ16.DataManager.getInstance().vialM = true;
                                _this.alpha = 0.0;
                            });
                            break;
                    }
                    break;
                case vialState.green:
                case vialState.hGreen:
                    switch (this.colorState) {
                        case vialState.hRedResult:
                            if (GGJ16.DataManager.getInstance().vialY) {
                                new GGJ16.Monologue(this.game, "I already got an Yellow Vial...");
                                return false;
                            }
                            this.loadTexture('vialYellowFull');
                            this.colorState = vialState.yellow;
                            // DataManager.getInstance().vialY = true;
                            new GGJ16.Monologue(this.game, "I got an Yellow Vial...");
                            GGJ16.DataManager.getInstance().canClick = false;
                            var tween = this.game.add.tween(this).to({ x: [0, this.width + 10], y: [this.position.y, 10] }, 500, "Sine.easeInOut", true, 0, 0, false);
                            tween.interpolation(Phaser.Math.bezierInterpolation);
                            tween.onComplete.add(function () {
                                GGJ16.DataManager.getInstance().canClick = true;
                                GGJ16.DataManager.getInstance().vialY = true;
                                _this.alpha = 0.0;
                            });
                            break;
                        case vialState.hBlueResult:
                            if (GGJ16.DataManager.getInstance().vialC) {
                                new GGJ16.Monologue(this.game, "I already got a Cyan Vial...");
                                return false;
                            }
                            this.loadTexture('vialCyanFull');
                            this.colorState = vialState.cyan;
                            // DataManager.getInstance().vialC = true;
                            new GGJ16.Monologue(this.game, "I got a Cyan Vial...");
                            GGJ16.DataManager.getInstance().canClick = false;
                            var tween = this.game.add.tween(this).to({ x: [0, this.width + 10], y: [this.position.y, 10] }, 500, "Sine.easeInOut", true, 0, 0, false);
                            tween.interpolation(Phaser.Math.bezierInterpolation);
                            tween.onComplete.add(function () {
                                GGJ16.DataManager.getInstance().canClick = true;
                                GGJ16.DataManager.getInstance().vialC = true;
                                _this.alpha = 0.0;
                            });
                            break;
                    }
                    break;
                case vialState.blue:
                case vialState.hBlue:
                    switch (this.colorState) {
                        case vialState.hRedResult:
                            if (GGJ16.DataManager.getInstance().vialM) {
                                new GGJ16.Monologue(this.game, "I already got a Magenta Vial...");
                                return false;
                            }
                            this.loadTexture('vialMagentaFull');
                            this.colorState = vialState.magenta;
                            // DataManager.getInstance().vialM = true;
                            new GGJ16.Monologue(this.game, "I got a Magenta Vial...");
                            GGJ16.DataManager.getInstance().canClick = false;
                            var tween = this.game.add.tween(this).to({ x: [0, this.width + 10], y: [this.position.y, 10] }, 500, "Sine.easeInOut", true, 0, 0, false);
                            tween.interpolation(Phaser.Math.bezierInterpolation);
                            tween.onComplete.add(function () {
                                GGJ16.DataManager.getInstance().canClick = true;
                                GGJ16.DataManager.getInstance().vialM = true;
                                _this.alpha = 0.0;
                            });
                            break;
                        case vialState.hGreenResult:
                            if (GGJ16.DataManager.getInstance().vialC) {
                                new GGJ16.Monologue(this.game, "I already got a Cyan Vial...");
                                return false;
                            }
                            this.loadTexture('vialCyanFull');
                            this.colorState = vialState.cyan;
                            // DataManager.getInstance().vialC = true;
                            new GGJ16.Monologue(this.game, "I got a Cyan Vial...");
                            GGJ16.DataManager.getInstance().canClick = false;
                            var tween = this.game.add.tween(this).to({ x: [0, this.width + 10], y: [this.position.y, 10] }, 500, "Sine.easeInOut", true, 0, 0, false);
                            tween.interpolation(Phaser.Math.bezierInterpolation);
                            tween.onComplete.add(function () {
                                GGJ16.DataManager.getInstance().canClick = true;
                                GGJ16.DataManager.getInstance().vialC = true;
                                _this.alpha = 0.0;
                            });
                            break;
                    }
                    break;
            }
            switch (this.id) {
                case 1:
                    GGJ16.DataManager.getInstance().vial1Presence = false;
                    break;
                case 2:
                    GGJ16.DataManager.getInstance().vial2Presence = false;
                    break;
                case 3:
                    GGJ16.DataManager.getInstance().vial3Presence = false;
                    break;
            }
            this.inputEnabled = false;
            // this.alpha = 0.0;
            return true;
        };
        Vial.prototype.useThePaint = function () {
            switch (this.colorState) {
                case vialState.red:
                    // this.g.add.tween(this).to( { alpha: 0.0 }, 2000, Phaser.Easing.Linear.None, true, 0, 1000, true);
                    // this.animating = true;
                    // var switchSprite: Phaser.Tween = this.game.add.tween(this.alpha).to(0.0, 500, Phaser.Easing.Linear.None, true);
                    // switchSprite.onComplete.add( () => {
                    //     this.loadTexture('vialRedHalf');
                    //     this.game.add.tween(this.alpha).to(1.0, 500, Phaser.Easing.Linear.None, true);
                    //     this.animating = false;
                    // }, this);
                    this.loadTexture('vialRedHalf');
                    this.colorState = vialState.hRed;
                    GGJ16.DataManager.getInstance().vialRStatus = this.colorState;
                    break;
                case vialState.hRed:
                    this.loadTexture('vialEmpty');
                    this.colorState = vialState.emptyUnusable;
                    GGJ16.DataManager.getInstance().vialRStatus = this.colorState;
                    break;
                case vialState.green:
                    this.loadTexture('vialGreenHalf');
                    this.colorState = vialState.hGreen;
                    GGJ16.DataManager.getInstance().vialGStatus = this.colorState;
                    break;
                case vialState.hGreen:
                    this.loadTexture('vialEmpty');
                    this.colorState = vialState.emptyUnusable;
                    GGJ16.DataManager.getInstance().vialGStatus = this.colorState;
                    break;
                case vialState.blue:
                    this.loadTexture('vialBlueHalf');
                    this.colorState = vialState.hBlue;
                    GGJ16.DataManager.getInstance().vialBStatus = this.colorState;
                    break;
                case vialState.hBlue:
                    this.loadTexture('vialEmpty');
                    this.colorState = vialState.emptyUnusable;
                    GGJ16.DataManager.getInstance().vialBStatus = this.colorState;
                    break;
            }
        };
        return Vial;
    })(Phaser.Sprite);
    GGJ16.Vial = Vial;
})(GGJ16 || (GGJ16 = {}));
/// <reference path="../../tsDefinitions/phaser.d.ts" />
var GGJ16;
(function (GGJ16) {
    var Boot = (function (_super) {
        __extends(Boot, _super);
        function Boot() {
            _super.apply(this, arguments);
        }
        Boot.prototype.preload = function () {
            this.load.spritesheet('animLoading', "assets/img/loading.png", 96, 96);
        };
        Boot.prototype.create = function () {
            this.game.stage.backgroundColor = 0xFFFFFF;
            this.game.state.start('Preload', true, false);
        };
        return Boot;
    })(Phaser.State);
    GGJ16.Boot = Boot;
})(GGJ16 || (GGJ16 = {}));
/// <reference path="../../tsDefinitions/phaser.d.ts" />
var GGJ16;
(function (GGJ16) {
    var Credits = (function (_super) {
        __extends(Credits, _super);
        function Credits() {
            _super.apply(this, arguments);
        }
        Credits.prototype.preload = function () {
        };
        Credits.prototype.create = function () {
            //this.game.stage.backgroundColor = 0x0FF;
            // this.game.state.start('Preload', true, false);
            var sprCredits = this.game.add.sprite(this.game.width * 0.5, this.game.height * 0.5, "menuCredits");
            sprCredits.anchor.set(0.5);
            var buttonBack = this.game.add.button(this.game.width * 0.1, this.game.height * 0.1, 'buttonBack', this.showMainMenu, this, 2, 1, 0);
            buttonBack.anchor.set(0.5);
            buttonBack.onInputOver.add(this.over, this);
            buttonBack.onInputOut.add(this.out, this);
            buttonBack.onInputUp.add(this.up, this);
        };
        Credits.prototype.up = function () {
            console.log('button up', arguments);
        };
        Credits.prototype.over = function () {
            console.log('button over');
        };
        Credits.prototype.out = function () {
            console.log('button out');
        };
        Credits.prototype.showMainMenu = function () {
            this.game.state.start("MainMenu");
        };
        return Credits;
    })(Phaser.State);
    GGJ16.Credits = Credits;
})(GGJ16 || (GGJ16 = {}));
/// <reference path="../../tsDefinitions/phaser.d.ts" />
var GGJ16;
(function (GGJ16) {
    var Intro = (function (_super) {
        __extends(Intro, _super);
        function Intro() {
            _super.apply(this, arguments);
        }
        Intro.prototype.preload = function () {
        };
        Intro.prototype.create = function () {
            this.skipKey = this.input.keyboard.addKey(Phaser.Keyboard.ENTER);
            this.nextKey = this.input.keyboard.addKey(Phaser.Keyboard.SPACEBAR);
            this.countProgress = 0;
            this.screens = new Array();
            this.screens.push(this.game.add.sprite(0, 0, 'intro1'));
            this.screens.push(this.game.add.sprite(0, 0, 'intro2'));
            this.screens.push(this.game.add.sprite(0, 0, 'intro3'));
            this.screens.push(this.game.add.sprite(0, 0, 'intro4'));
            this.screens.push(this.game.add.sprite(0, 0, 'intro5'));
            this.screens.push(this.game.add.sprite(0, 0, 'intro6'));
            this.screens.push(this.game.add.sprite(0, 0, 'intro7'));
            this.screens.push(this.game.add.sprite(0, 0, 'intro8'));
            this.screens.push(this.game.add.sprite(0, 0, 'intro9'));
            for (var i = 0; i < this.screens.length; i++)
                this.screens[i].alpha = 0.0;
            this.stage.backgroundColor = 0x000000;
            this.fadeInTime = 800;
            this.stayTime = 5000;
            this.fadeOutTime = 350;
            this.loadIntro1();
        };
        Intro.prototype.update = function () {
            if (this.skipKey.justDown) {
                this.game.tweens.removeAll();
                this.game.state.start('Room1', true, false);
            }
            if (this.nextKey.justDown) {
                this.game.tweens.removeAll();
                this.zeroAlphaAllScreens();
                switch (this.countProgress) {
                    case 0:
                        this.loadIntro2();
                        break;
                    case 1:
                        this.loadIntro3();
                        break;
                    case 2:
                        this.loadIntro4();
                        break;
                    case 3:
                        this.loadIntro5();
                        break;
                    case 4:
                        this.loadIntro6();
                        break;
                    case 5:
                        this.loadIntro7();
                        break;
                    case 6:
                        this.loadIntro8();
                        break;
                    case 7:
                        this.loadIntro9();
                        break;
                    case 8:
                        this.game.tweens.removeAll();
                        this.game.state.start('Room1', true, false);
                        break;
                }
            }
        };
        Intro.prototype.zeroAlphaAllScreens = function () {
            for (var i = 0; i < this.screens.length; i++)
                this.screens[i].alpha = 0.0;
        };
        Intro.prototype.loadIntro1 = function () {
            this.game.add.tween(this.screens[0]).to({ alpha: 1.0 }, this.fadeInTime, Phaser.Easing.Linear.None, true); //.onComplete.add(this.unloadIntro1, this);
        };
        Intro.prototype.unloadIntro1 = function () {
            this.game.add.tween(this.screens[0]).to({ alpha: 0.0 }, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro2, this);
        };
        Intro.prototype.loadIntro2 = function () {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[1]).to({ alpha: 1.0 }, this.fadeInTime, Phaser.Easing.Linear.None, true); //.onComplete.add(this.unloadIntro2, this);
        };
        Intro.prototype.unloadIntro2 = function () {
            this.game.add.tween(this.screens[1]).to({ alpha: 0.0 }, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro3, this);
        };
        Intro.prototype.loadIntro3 = function () {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[2]).to({ alpha: 1.0 }, this.fadeInTime, Phaser.Easing.Linear.None, true); //.onComplete.add(this.unloadIntro3, this);
        };
        Intro.prototype.unloadIntro3 = function () {
            this.game.add.tween(this.screens[2]).to({ alpha: 0.0 }, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro4, this);
        };
        Intro.prototype.loadIntro4 = function () {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[3]).to({ alpha: 1.0 }, this.fadeInTime, Phaser.Easing.Linear.None, true); //.onComplete.add(this.unloadIntro4, this);
        };
        Intro.prototype.unloadIntro4 = function () {
            this.game.add.tween(this.screens[3]).to({ alpha: 0.0 }, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro5, this);
        };
        Intro.prototype.loadIntro5 = function () {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[4]).to({ alpha: 1.0 }, this.fadeInTime, Phaser.Easing.Linear.None, true); //.onComplete.add(this.unloadIntro5, this);
        };
        Intro.prototype.unloadIntro5 = function () {
            this.game.add.tween(this.screens[4]).to({ alpha: 0.0 }, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro6, this);
        };
        Intro.prototype.loadIntro6 = function () {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[5]).to({ alpha: 1.0 }, this.fadeInTime, Phaser.Easing.Linear.None, true); //.onComplete.add(this.unloadIntro6, this);
        };
        Intro.prototype.unloadIntro6 = function () {
            this.game.add.tween(this.screens[5]).to({ alpha: 0.0 }, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro7, this);
        };
        Intro.prototype.loadIntro7 = function () {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[6]).to({ alpha: 1.0 }, this.fadeInTime, Phaser.Easing.Linear.None, true); //.onComplete.add(this.unloadIntro7, this);
        };
        Intro.prototype.unloadIntro7 = function () {
            this.game.add.tween(this.screens[6]).to({ alpha: 0.0 }, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro8, this);
        };
        Intro.prototype.loadIntro8 = function () {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[7]).to({ alpha: 1.0 }, this.fadeInTime, Phaser.Easing.Linear.None, true); //.onComplete.add(this.unloadIntro8, this);
        };
        Intro.prototype.unloadIntro8 = function () {
            this.game.add.tween(this.screens[7]).to({ alpha: 0.0 }, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro9, this);
        };
        Intro.prototype.loadIntro9 = function () {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[8]).to({ alpha: 1.0 }, this.fadeInTime, Phaser.Easing.Linear.None, true); //.onComplete.add(this.unloadIntro9, this);
        };
        Intro.prototype.unloadIntro9 = function () {
            this.game.add.tween(this.screens[8]).to({ alpha: 0.0 }, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.goToGame, this);
        };
        Intro.prototype.goToGame = function () {
            this.game.state.start('Room1', true, false, true);
        };
        return Intro;
    })(Phaser.State);
    GGJ16.Intro = Intro;
})(GGJ16 || (GGJ16 = {}));
/// <reference path="../../tsDefinitions/phaser.d.ts" />
var GGJ16;
(function (GGJ16) {
    var MainMenu = (function (_super) {
        __extends(MainMenu, _super);
        function MainMenu() {
            _super.apply(this, arguments);
        }
        MainMenu.prototype.preload = function () {
        };
        MainMenu.prototype.create = function () {
            GGJ16.DataManager.getInstance().initValues();
            var buttonCredits = this.game.add.button(this.game.width * 0.5, this.game.height * 0.75, 'buttonCredits', this.showCredits, this, 2, 1, 0);
            buttonCredits.anchor.set(0.5);
            buttonCredits.onInputOver.add(this.creditsOver, this);
            buttonCredits.onInputOut.add(this.creditsOut, this);
            buttonCredits.onInputUp.add(this.up, this);
            var buttonPlay = this.game.add.button(this.game.width / 2, this.game.height * 0.6, 'buttonPlay', this.playTheGame, this);
            buttonPlay.anchor.set(0.5);
            var mainMenuImage = this.game.add.sprite(this.game.width / 2, this.game.height / 2, 'mainMenuImage');
            mainMenuImage.anchor.set(0.5);
            mainMenuImage.sendToBack();
            var gameTitle = this.game.add.sprite(this.game.width / 2, this.game.height * 0.3, 'gameTitle');
            gameTitle.anchor.set(0.5);
            gameTitle.bringToTop();
        };
        MainMenu.prototype.up = function () {
            console.log('button up', arguments);
        };
        MainMenu.prototype.creditsOver = function () {
            console.log('button over');
        };
        MainMenu.prototype.creditsOut = function () {
            console.log('button out');
        };
        MainMenu.prototype.playTheGame = function () {
            this.game.state.start("Intro");
        };
        MainMenu.prototype.showCredits = function () {
            this.game.state.start("Credits");
        };
        return MainMenu;
    })(Phaser.State);
    GGJ16.MainMenu = MainMenu;
})(GGJ16 || (GGJ16 = {}));
/// <reference path="../../tsDefinitions/phaser.d.ts" />
var GGJ16;
(function (GGJ16) {
    var Outro = (function (_super) {
        __extends(Outro, _super);
        function Outro() {
            _super.apply(this, arguments);
        }
        Outro.prototype.preload = function () {
        };
        Outro.prototype.create = function () {
            this.skipKey = this.input.keyboard.addKey(Phaser.Keyboard.ENTER);
            this.nextKey = this.input.keyboard.addKey(Phaser.Keyboard.SPACEBAR);
            this.countProgress = 0;
            this.screens = new Array();
            this.screens.push(this.game.add.sprite(0, 0, 'outro1'));
            this.screens.push(this.game.add.sprite(0, 0, 'outro2'));
            this.screens.push(this.game.add.sprite(0, 0, 'outro3'));
            this.screens.push(this.game.add.sprite(0, 0, 'outro4'));
            this.screens.push(this.game.add.sprite(0, 0, 'outro5'));
            for (var i = 0; i < this.screens.length; i++)
                this.screens[i].alpha = 0.0;
            this.stage.backgroundColor = 0x000000;
            this.fadeInTime = 500;
            this.stayTime = 5000;
            this.fadeOutTime = 450;
            this.loadIntro1();
        };
        Outro.prototype.update = function () {
            if (this.skipKey.justDown) {
                this.game.tweens.removeAll();
                this.game.state.start('MainMenu', true, false);
            }
            if (this.nextKey.justDown) {
                this.game.tweens.removeAll();
                this.zeroAlphaAllScreens();
                switch (this.countProgress) {
                    case 0:
                        this.loadIntro2();
                        break;
                    case 1:
                        this.loadIntro3();
                        break;
                    case 2:
                        this.loadIntro4();
                        break;
                    case 3:
                        this.loadIntro5();
                        break;
                    case 4:
                        this.game.tweens.removeAll();
                        this.game.state.start('MainMenu', true, false);
                        break;
                }
            }
        };
        Outro.prototype.zeroAlphaAllScreens = function () {
            for (var i = 0; i < this.screens.length; i++)
                this.screens[i].alpha = 0.0;
        };
        Outro.prototype.loadIntro1 = function () {
            this.game.add.tween(this.screens[0]).to({ alpha: 1.0 }, this.fadeInTime, Phaser.Easing.Linear.None, true); //.onComplete.add(this.unloadIntro1, this);
        };
        Outro.prototype.unloadIntro1 = function () {
            this.game.add.tween(this.screens[0]).to({ alpha: 0.0 }, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro2, this);
        };
        Outro.prototype.loadIntro2 = function () {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[1]).to({ alpha: 1.0 }, this.fadeInTime, Phaser.Easing.Linear.None, true); //.onComplete.add(this.unloadIntro2, this);
        };
        Outro.prototype.unloadIntro2 = function () {
            this.game.add.tween(this.screens[1]).to({ alpha: 0.0 }, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro3, this);
        };
        Outro.prototype.loadIntro3 = function () {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[2]).to({ alpha: 1.0 }, this.fadeInTime, Phaser.Easing.Linear.None, true); //.onComplete.add(this.unloadIntro3, this);
        };
        Outro.prototype.unloadIntro3 = function () {
            this.game.add.tween(this.screens[2]).to({ alpha: 0.0 }, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro4, this);
        };
        Outro.prototype.loadIntro4 = function () {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[3]).to({ alpha: 1.0 }, this.fadeInTime, Phaser.Easing.Linear.None, true); //.onComplete.add(this.unloadIntro4, this);
        };
        Outro.prototype.unloadIntro4 = function () {
            this.game.add.tween(this.screens[3]).to({ alpha: 0.0 }, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro5, this);
        };
        Outro.prototype.loadIntro5 = function () {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[4]).to({ alpha: 1.0 }, this.fadeInTime, Phaser.Easing.Linear.None, true); //.onComplete.add(this.unloadIntro5, this);
        };
        Outro.prototype.unloadIntro5 = function () {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[4]).to({ alpha: 0.0 }, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.goToEnd, this);
        };
        Outro.prototype.goToEnd = function () {
            GGJ16.DataManager.getInstance().initValues();
            this.game.state.start('MainMenu', true, false);
        };
        return Outro;
    })(Phaser.State);
    GGJ16.Outro = Outro;
})(GGJ16 || (GGJ16 = {}));
/// <reference path="../../tsDefinitions/phaser.d.ts" />
/// <reference path="../Main.ts" />
var GGJ16;
(function (GGJ16) {
    var Preload = (function (_super) {
        __extends(Preload, _super);
        function Preload() {
            _super.apply(this, arguments);
        }
        Preload.prototype.preload = function () {
            this.animLoading = this.add.sprite(this.world.centerX, this.world.centerY, 'animLoading', 0);
            this.animLoading.anchor.set(0.5, 0.5);
            this.animLoading.animations.add('loading');
            this.animLoading.animations.play('loading', 8, true);
            this.load.bitmapFont('chillerBlack', 'assets/other/chillerBlack.png', 'assets/other/chillerBlack.fnt');
            this.load.tilemap('room1JSON', 'assets/json/room1.json', null, Phaser.Tilemap.TILED_JSON);
            this.load.tilemap('room2JSON', 'assets/json/room2.json', null, Phaser.Tilemap.TILED_JSON);
            // this.load.image('atlas', 'assets/img/atlas.png');
            // this.load.image('roundy', 'assets/img/roundy.png');
            // this.load.image('star', 'assets/img/star.png');
            // this.load.audio('bgmusic', ['assets/music/bgmusic.mp3', 'assets/music/bgmusic.ogg']);
            // this.load.audio('jump', ['assets/sfx/jump.wav', 'assets/sfx/jump.ogg']);
            //buttons
            this.game.load.spritesheet('buttonCredits', 'assets/img/btnCredits.png', 259, 109);
            this.game.load.spritesheet('buttonBack', 'assets/img/buttonBack.png', 163, 77);
            this.game.load.image('buttonPlay', 'assets/img/btnPlay.png');
            this.game.load.image('menuCredits', 'assets/img/menuCredits.png');
            this.game.load.image('mainMenuImage', 'assets/img/menubg.png');
            this.game.load.image('gameTitle', 'assets/img/gameTitle.png');
            //Puzzle 2
            this.game.load.image('vialRedFull', 'assets/img/vialRedFull.png');
            this.game.load.image('vialRedHalf', 'assets/img/vialRedHalf.png');
            this.game.load.image('vialGreenFull', 'assets/img/vialGreenFull.png');
            this.game.load.image('vialGreenHalf', 'assets/img/vialGreenHalf.png');
            this.game.load.image('vialBlueFull', 'assets/img/vialBlueFull.png');
            this.game.load.image('vialBlueHalf', 'assets/img/vialBlueHalf.png');
            this.game.load.image('vialYellowFull', 'assets/img/vialYellowFull.png');
            this.game.load.image('vialCyanFull', 'assets/img/vialCyanFull.png');
            this.game.load.image('vialMagentaFull', 'assets/img/vialMagentaFull.png');
            this.game.load.image('vialEmpty', 'assets/img/vialEmpty.png');
            this.game.load.image('locker', 'assets/img/locker.png');
            this.game.load.image('lockerOpen', 'assets/img/lockerOpen.png');
            this.game.load.image('room2bg', 'assets/img/room2bg.png');
            //Puzzle 1
            this.game.load.image('bottomDrawerClosed', 'assets/img/bottomDrawerClosed.png');
            this.game.load.image('bottomDrawerOpenWithRuby', 'assets/img/bottomDrawerOpenWithRuby.png');
            this.game.load.image('bottomDrawerOpenNoRuby', 'assets/img/bottomDrawerOpenNoRuby.png');
            this.game.load.image('topDrawerClosed', 'assets/img/topDrawerClosed.png');
            this.game.load.image('topDrawerOpenWithPiece', 'assets/img/topDrawerOpenWithPiece.png');
            this.game.load.image('topDrawerOpenNoPiece', 'assets/img/topDrawerOpenNoPiece.png');
            this.game.load.image('skullMissingEye', 'assets/img/skullMissingEye.png');
            this.game.load.image('skullMouthOpenWithKey', 'assets/img/skullMouthOpenWithKey.png');
            this.game.load.image('skullMouthOpenNoKey', 'assets/img/skullMouthOpenNoKey.png');
            this.game.load.image('chest', 'assets/img/chest.png');
            this.game.load.image('key', 'assets/img/key.png');
            this.game.load.image('ruby', 'assets/img/ruby.png');
            this.game.load.image('note', 'assets/img/note.png');
            this.game.load.image('noteBig', 'assets/img/noteBig.png');
            this.game.load.image('room1bg', 'assets/img/room1bg.png');
            //Miscelaneous
            this.game.load.image('arrowLeft', 'assets/img/arrowLeft.png');
            this.game.load.image('arrowRight', 'assets/img/arrowRight.png');
            this.game.load.image('arrowDown', 'assets/img/arrowDown.png');
            this.load.image('piece1puzzle64', 'assets/img/piece1puzzle64.png');
            this.load.image('piece2puzzle64', 'assets/img/piece2puzzle64.png');
            this.load.image('piece3puzzle64', 'assets/img/piece3puzzle64.png');
            //
            // NOTE: Puzzle5 Assets
            //
            this.game.load.tilemap('puzzle5jsn', 'assets/json/puzzle5.json', null, Phaser.Tilemap.TILED_JSON);
            this.load.image('puzzle5bg', 'assets/img/puzzle5bg.png');
            this.load.image('piece1puzzle', 'assets/img/piece1puzzle.png');
            this.load.image('piece2puzzle', 'assets/img/piece2puzzle.png');
            this.load.image('piece3puzzle', 'assets/img/piece3puzzle.png');
            this.load.image('piece4puzzle', 'assets/img/piece4puzzle.png');
            this.load.image('piece5puzzle', 'assets/img/piece5puzzle.png');
            this.load.image('piece6puzzle', 'assets/img/piece6puzzle.png');
            this.load.image('piece7puzzle', 'assets/img/piece7puzzle.png');
            this.load.image('piece8puzzle', 'assets/img/piece8puzzle.png');
            //
            // NOTE: Puzzle4 Assets
            //
            this.game.load.tilemap('puzzle4jsn', 'assets/json/puzzle4.json', null, Phaser.Tilemap.TILED_JSON);
            this.load.image('puzzle4bg', 'assets/img/puzzle4bg.png');
            this.load.image('ubtn', 'assets/img/ubtn.png');
            this.load.image('dbtn', 'assets/img/dbtn.png');
            //
            // NOTE: Room 3 - with the snake statue
            //
            this.game.load.tilemap('room3jsn', 'assets/json/room3.json', null, Phaser.Tilemap.TILED_JSON);
            this.load.image('room3bg', 'assets/img/room3bg.png');
            this.load.image('statueClosed', 'assets/img/statueClosed.png');
            this.load.image('statueSolved', 'assets/img/statueSolved.png');
            //
            // NOTE: Puzzle3 Assets
            //
            this.game.load.tilemap('puzzle3jsn', 'assets/json/puzzle3.json', null, Phaser.Tilemap.TILED_JSON);
            // this.load.image('puzzle3bg', 'assets/img/puzzle3bg.png');
            this.load.image('statueClosedZoom', 'assets/img/statueClosedZoom.png');
            this.load.image('statueSolvedZoom', 'assets/img/statueSolvedZoom.png');
            this.load.onLoadComplete.add(this.startGame, this);
            //
            // NOTE: Intro screens
            //
            this.load.image('intro1', 'assets/img/intro1.png');
            this.load.image('intro2', 'assets/img/intro2.png');
            this.load.image('intro3', 'assets/img/intro3.png');
            this.load.image('intro4', 'assets/img/intro4.png');
            this.load.image('intro5', 'assets/img/intro5.png');
            this.load.image('intro6', 'assets/img/intro6.png');
            this.load.image('intro7', 'assets/img/intro7.png');
            this.load.image('intro8', 'assets/img/intro8.png');
            this.load.image('intro9', 'assets/img/intro9.png');
            //
            // NOTE: Outro screens
            //
            this.load.image('outro1', 'assets/img/outro1.png');
            this.load.image('outro2', 'assets/img/outro2.png');
            this.load.image('outro3', 'assets/img/outro3.png');
            this.load.image('outro4', 'assets/img/outro4.png');
            this.load.image('outro5', 'assets/img/outro5.png');
            //
            // NOTE: Sound Effects and Music
            //
            this.load.audio('drag', 'assets/sfx/drag pieces puzzle.mp3');
            this.load.audio('drawers', 'assets/sfx/drawers.mp3');
            this.load.audio('fillvial', 'assets/sfx/fill vial.mp3');
            this.load.audio('pickvial', 'assets/sfx/pick vial.mp3');
            this.load.audio('success', 'assets/sfx/general-success.mp3');
            this.load.audio('key', 'assets/sfx/key.mp3');
            this.load.audio('openlocker', 'assets/sfx/open locker.mp3');
            this.load.audio('pickpaper', 'assets/sfx/pick paper.mp3');
            this.load.audio('pickruby', 'assets/sfx/ruby.mp3');
            this.load.audio('skullstatue', 'assets/sfx/skull and statue.mp3');
            this.load.audio('unlock', 'assets/sfx/unlock stuff.mp3');
            this.load.audio('offgame', 'assets/music/offgame.mp3');
            this.load.audio('footsteps', 'assets/sfx/footsteps.mp3');
            this.load.audio('scream', 'assets/sfx/scream.mp3');
        };
        Preload.prototype.startGame = function () {
            // this.game.state.start('Puzzle3', true, false);
            // this.game.state.start('Room1', true, false);
            // this.game.state.start('MainMenu', true, false);
            this.game.add.audio('offgame', 1, true).play();
            this.game.state.start('MainMenu', true, false);
            // this.game.state.start('Intro', true, false);
        };
        return Preload;
    })(Phaser.State);
    GGJ16.Preload = Preload;
})(GGJ16 || (GGJ16 = {}));
/// <reference path="../../tsDefinitions/phaser.d.ts" />
/// <reference path="../DataManager.ts" />
/// <reference path="../Monologue.ts" />
var GGJ16;
(function (GGJ16) {
    var Puzzle3 = (function (_super) {
        __extends(Puzzle3, _super);
        function Puzzle3() {
            _super.apply(this, arguments);
        }
        //
        // NOTE: Phaser Standard Methods
        //
        Puzzle3.prototype.create = function () {
            //Local vars
            this.stage.backgroundColor = 0x222222;
            this.sfxUnlock = this.game.add.audio('unlock');
            this.sfxFootsteps = this.game.add.audio('footsteps');
            this.sfxSuccess = this.game.add.audio('success');
            //Map routines
            this.jsnLevel = this.add.tilemap('puzzle3jsn', 1200, 760, 1, 1);
            this.jsnLevel.createLayer('tiles').resizeWorld();
            this.inventory = new GGJ16.Inventory(this.game);
            this.createStatue();
            this.arrowBack = new Phaser.Sprite(this.game, 10, 80, 'arrowLeft');
            this.arrowBack.inputEnabled = true;
            this.arrowBack.scale.set(1.5);
            this.game.add.existing(this.arrowBack);
            this.arrowBack.events.onInputOver.add(this.overArrowBack, this);
            this.arrowBack.events.onInputDown.add(this.clickedArrowBack, this);
            this.arrowBack.events.onInputOut.add(this.outArrowBack, this);
            this.arrowBack.alpha = 0.5;
        };
        Puzzle3.prototype.clickedArrowBack = function () {
            if (GGJ16.DataManager.getInstance().canClick) {
                this.sfxFootsteps.play();
                this.game.state.start('Room3', true, false);
            }
        };
        Puzzle3.prototype.overArrowBack = function () {
            this.arrowBack.alpha = 1.0;
        };
        Puzzle3.prototype.outArrowBack = function () {
            this.arrowBack.alpha = 0.5;
        };
        //
        // NOTE: Custom Methods
        //
        Puzzle3.prototype.findObjectsByType = function (type) {
            var objs = new Array();
            this.jsnLevel.objects['objects'].forEach(function (element) {
                if (element.name === type)
                    objs.push(element);
            });
            return objs;
        };
        Puzzle3.prototype.createStatue = function () {
            var _this = this;
            this.findObjectsByType('statue').forEach(function (element) {
                if (!GGJ16.DataManager.getInstance().puzzle3Done) {
                    _this.statue = new Phaser.Sprite(_this.game, element.x + element.width / 2, element.y + element.height / 2, 'statueClosedZoom');
                }
                else {
                    _this.statue = new Phaser.Sprite(_this.game, element.x + element.width / 2, element.y + element.height / 2, 'statueSolvedZoom');
                }
                _this.game.add.existing(_this.statue);
                _this.statue.anchor.set(0.5);
                _this.statue.inputEnabled = true;
                _this.statue.events.onInputDown.add(_this.handleClick, _this);
            }, this);
        };
        Puzzle3.prototype.update = function () {
            this.inventory.tick();
        };
        Puzzle3.prototype.handleClick = function () {
            var _this = this;
            if (!GGJ16.DataManager.getInstance().canClick) {
                return;
            }
            if (!GGJ16.DataManager.getInstance().puzzle3Done) {
                if (GGJ16.DataManager.getInstance().vialY && GGJ16.DataManager.getInstance().vialC && GGJ16.DataManager.getInstance().vialM) {
                    new GGJ16.Monologue(this.game, "I got a piece... and it seems there's something written on the wall.");
                    this.statue.loadTexture('statueSolvedZoom');
                    this.sfxUnlock.play();
                    this.sfxSuccess.play();
                    //create piece1, interpolate to Inv
                    this.piece1 = new Phaser.Sprite(this.game, this.statue.position.x, this.statue.position.y, 'piece1puzzle64');
                    this.piece1.position.set(this.statue.position.x - this.piece1.width / 2, this.statue.position.y - this.piece1.height / 2);
                    this.game.add.existing(this.piece1);
                    // new Monologue(this.game, "Hmmm, what is this?");
                    GGJ16.DataManager.getInstance().canClick = false;
                    var tween = this.game.add.tween(this.piece1).to({ x: [0, this.piece1.width + 10], y: [this.piece1.position.y, 10] }, 1000, "Sine.easeInOut", true, 0, 0, false);
                    tween.interpolation(Phaser.Math.bezierInterpolation);
                    tween.onComplete.add(function () {
                        GGJ16.DataManager.getInstance().canClick = true;
                        GGJ16.DataManager.getInstance().piece3 = true;
                        _this.piece1.destroy();
                    });
                    GGJ16.DataManager.getInstance().puzzle3Done = true;
                    GGJ16.DataManager.getInstance().vialY = false;
                    GGJ16.DataManager.getInstance().vialC = false;
                    GGJ16.DataManager.getInstance().vialM = false;
                }
                else {
                    new GGJ16.Monologue(this.game, "These vials need to be filled with something, but what?");
                }
            }
            else {
                new GGJ16.Monologue(this.game, "Hmmm, there's some kind of code in the wall...");
            }
        };
        return Puzzle3;
    })(Phaser.State);
    GGJ16.Puzzle3 = Puzzle3;
})(GGJ16 || (GGJ16 = {}));
/// <reference path="../../tsDefinitions/phaser.d.ts" />
/// <reference path="../DataManager.ts" />
/// <reference path="../Monologue.ts" />
//
var GGJ16;
(function (GGJ16) {
    var Puzzle4 = (function (_super) {
        __extends(Puzzle4, _super);
        function Puzzle4() {
            _super.apply(this, arguments);
        }
        //
        // NOTE: Phaser Standard Methods
        //
        Puzzle4.prototype.create = function () {
            //Local vars
            this.stage.backgroundColor = 0x222222;
            this.canGoBack = false;
            this.clickedLastFrame = false;
            this.buttons = new Array();
            this.sequence = [1, 3, 5, 2, 4];
            this.countProgress = 0;
            this.nextIdx = this.sequence[this.countProgress];
            this.inventory = new GGJ16.Inventory(this.game);
            this.sfxFootsteps = this.game.add.audio('footsteps');
            this.sfxPickPaper = this.game.add.audio('pickpaper');
            this.sfxSuccess = this.game.add.audio('success');
            this.sfxUnlock = this.game.add.audio('unlock');
            this.sfxGrab = this.game.add.audio('drag');
            //Map routines
            this.jsnLevel = this.add.tilemap('puzzle4jsn', 1200, 760, 1, 1);
            this.jsnLevel.addTilesetImage('puzzle4bg');
            this.jsnLevel.createLayer('tiles').resizeWorld();
            this.createButtons();
            // this.arrowBack = new Phaser.Sprite(this.game, this.game.world.centerX, this.game.world.height - 80, 'arrowDown');
            // this.arrowBack.inputEnabled = true;
            // this.game.add.existing(this.arrowBack);
            // this.arrowBack.events.onInputOver.add(this.overArrowBack, this);
            // this.arrowBack.events.onInputDown.add(this.clickedArrowBack, this);
            // this.arrowBack.events.onInputOut.add(this.outArrowBack, this);
            // this.arrowBack.alpha = 0.2;
            this.arrowBack = new Phaser.Sprite(this.game, 10, 80, 'arrowLeft');
            this.arrowBack.inputEnabled = true;
            this.arrowBack.scale.set(1.5);
            this.game.add.existing(this.arrowBack);
            this.arrowBack.events.onInputOver.add(this.overArrowBack, this);
            this.arrowBack.events.onInputDown.add(this.clickedArrowBack, this);
            this.arrowBack.events.onInputOut.add(this.outArrowBack, this);
            this.arrowBack.alpha = 0.5;
        };
        //
        // NOTE: Custom Methods
        //
        Puzzle4.prototype.clickedArrowBack = function () {
            if (GGJ16.DataManager.getInstance().canClick) {
                this.sfxFootsteps.play();
                this.game.state.start('Room2', true, false);
            }
        };
        Puzzle4.prototype.overArrowBack = function () {
            this.arrowBack.alpha = 1.0;
        };
        Puzzle4.prototype.outArrowBack = function () {
            this.arrowBack.alpha = 0.2;
        };
        Puzzle4.prototype.handleClick = function () {
            // if( DataManager.getInstance().piece1 &&
            //     DataManager.getInstance().piece2 &&
            //     DataManager.getInstance().piece3 &&
            //     !DataManager.getInstance().piece1Placed &&
            //     !DataManager.getInstance().piece2Placed &&
            //     !DataManager.getInstance().piece3Placed &&
            //     DataManager.getInstance().note )
            //     {
            //     }
            //  else
            //  {
            //      new Monologue(this.game, "It feels like something is missing...");
            //  }
        };
        Puzzle4.prototype.update = function () {
            this.inventory.tick();
            if (GGJ16.DataManager.getInstance().lockerOpen && !GGJ16.DataManager.getInstance().lockerDone) {
                // DataManager.getInstance().piece2 = true;
                // DataManager.getInstance().note = true;
                GGJ16.DataManager.getInstance().lockerDone = true;
                GGJ16.DataManager.getInstance().showPieceMonologue = true;
                this.sfxFootsteps.play();
                this.game.state.start('Room2', true, false);
            }
        };
        Puzzle4.prototype.goBack = function () {
            debugger;
            this.canGoBack = true;
        };
        Puzzle4.prototype.createButtons = function () {
            var p = this.findObjectsByType('b1')[0];
            this.buttons.push(new GGJ16.Puzzle4Button(this, 'ubtn', p.x, p.y, 1));
            var p = this.findObjectsByType('b2')[0];
            this.buttons.push(new GGJ16.Puzzle4Button(this, 'ubtn', p.x, p.y, 2));
            var p = this.findObjectsByType('b3')[0];
            this.buttons.push(new GGJ16.Puzzle4Button(this, 'ubtn', p.x, p.y, 3));
            var p = this.findObjectsByType('b4')[0];
            this.buttons.push(new GGJ16.Puzzle4Button(this, 'ubtn', p.x, p.y, 4));
            var p = this.findObjectsByType('b5')[0];
            this.buttons.push(new GGJ16.Puzzle4Button(this, 'ubtn', p.x, p.y, 5));
        };
        Puzzle4.prototype.findObjectsByType = function (type) {
            var objs = new Array();
            this.jsnLevel.objects['objects'].forEach(function (element) {
                if (element.name === type)
                    objs.push(element);
            });
            return objs;
        };
        Puzzle4.prototype.resetButtons = function () {
            for (var i = 0; i < this.buttons.length; i++) {
                this.buttons[i].state = 0;
                this.buttons[i].loadTexture('ubtn');
            }
            this.countProgress = 0;
            this.nextIdx = this.sequence[this.countProgress];
        };
        return Puzzle4;
    })(Phaser.State);
    GGJ16.Puzzle4 = Puzzle4;
})(GGJ16 || (GGJ16 = {}));
/// <reference path="../../tsDefinitions/phaser.d.ts" />
/// <reference path="../DataManager.ts" />
/// <reference path="../Puzzle5Piece.ts"/>
/// <reference path="../Monologue.ts" />
var GGJ16;
(function (GGJ16) {
    var Puzzle5 = (function (_super) {
        __extends(Puzzle5, _super);
        function Puzzle5() {
            _super.apply(this, arguments);
        }
        //
        // NOTE: Phaser Standard Methods
        //
        Puzzle5.prototype.create = function () {
            //Local vars
            this.stage.backgroundColor = 0x222222;
            this.clickedLastFrame = false;
            this.minigameCanRun = false;
            this.pieceMoving = false;
            this.pieces = new Array();
            this.numPieceDimensions = 150;
            this.sfxMovePiece = this.game.add.audio('drag');
            this.sfxPlacePiece = this.game.add.audio('unlock');
            this.sfxSuccess = this.game.add.audio('success');
            this.sfxFootsteps = this.game.add.audio('footsteps');
            this.sfxScream = this.game.add.audio('scream');
            this.inventory = new GGJ16.Inventory(this.game);
            //Map routines
            this.jsnLevel = this.add.tilemap('puzzle5jsn', 1200, 760, 1, 1);
            this.jsnLevel.addTilesetImage('puzzle5bg');
            this.jsnLevel.createLayer('tiles').resizeWorld();
            // this.arrowBack = new Phaser.Sprite(this.game, this.game.world.centerX, this.game.world.height - 80, 'arrowDown');
            // this.arrowBack.inputEnabled = true;
            // this.game.add.existing(this.arrowBack);
            // this.arrowBack.events.onInputOver.add(this.overArrowBack, this);
            // this.arrowBack.events.onInputDown.add(this.clickedArrowBack, this);
            // this.arrowBack.events.onInputOut.add(this.outArrowBack, this);
            // this.arrowBack.alpha = 0.2;
            this.arrowBack = new Phaser.Sprite(this.game, 10, 80, 'arrowLeft');
            this.arrowBack.inputEnabled = true;
            this.arrowBack.scale.set(1.5);
            this.game.add.existing(this.arrowBack);
            this.arrowBack.events.onInputOver.add(this.overArrowBack, this);
            this.arrowBack.events.onInputDown.add(this.clickedArrowBack, this);
            this.arrowBack.events.onInputOut.add(this.outArrowBack, this);
            this.arrowBack.alpha = 0.5;
            this.positionPieces();
        };
        Puzzle5.prototype.clickedArrowBack = function () {
            this.sfxFootsteps.play();
            this.game.state.start('Room1', true, false);
        };
        Puzzle5.prototype.overArrowBack = function () {
            this.arrowBack.alpha = 1.0;
        };
        Puzzle5.prototype.outArrowBack = function () {
            this.arrowBack.alpha = 0.2;
        };
        Puzzle5.prototype.update = function () {
            this.inventory.tick();
            if (!this.pieceMoving) {
                if (this.game.input.activePointer.isDown && !this.clickedLastFrame) {
                    this.handleClick();
                    this.clickedLastFrame = true;
                }
                if (this.game.input.activePointer.isUp && this.clickedLastFrame) {
                    this.clickedLastFrame = false;
                }
                this.checkEndGame();
            }
        };
        //
        // NOTE: Custom Methods
        //
        Puzzle5.prototype.handleClick = function () {
            if (GGJ16.DataManager.getInstance().piece1 &&
                GGJ16.DataManager.getInstance().piece2 &&
                GGJ16.DataManager.getInstance().piece3 &&
                !GGJ16.DataManager.getInstance().piece1Placed &&
                !GGJ16.DataManager.getInstance().piece2Placed &&
                !GGJ16.DataManager.getInstance().piece3Placed &&
                GGJ16.DataManager.getInstance().note) {
                this.game.add.tween(this.pieces[0]).to({ alpha: 1.0 }, 350, Phaser.Easing.Linear.None, true);
                this.game.add.tween(this.pieces[1]).to({ alpha: 1.0 }, 350, Phaser.Easing.Linear.None, true);
                this.game.add.tween(this.pieces[2]).to({ alpha: 1.0 }, 350, Phaser.Easing.Linear.None, true);
                // this.pieces[0].alpha = 1.0;
                // this.pieces[1].alpha = 1.0;
                // this.pieces[2].alpha = 1.0;
                this.sfxPlacePiece.play();
                GGJ16.DataManager.getInstance().piece1Placed = true;
                GGJ16.DataManager.getInstance().piece2Placed = true;
                GGJ16.DataManager.getInstance().piece3Placed = true;
                GGJ16.DataManager.getInstance().piece1 = false;
                GGJ16.DataManager.getInstance().piece2 = false;
                GGJ16.DataManager.getInstance().piece3 = false;
                this.minigameCanRun = true;
                this.game.add.existing(this.note);
                GGJ16.DataManager.getInstance().note = false;
                GGJ16.DataManager.getInstance().notePlaced = true;
            }
            else if ((!GGJ16.DataManager.getInstance().piece1 ||
                !GGJ16.DataManager.getInstance().piece2 ||
                !GGJ16.DataManager.getInstance().piece3) &&
                (!GGJ16.DataManager.getInstance().note && !GGJ16.DataManager.getInstance().notePlaced)) {
                if (this.game.input.activePointer.position.y > 60) {
                    new GGJ16.Monologue(this.game, "It feels like something is missing...");
                }
            }
        };
        Puzzle5.prototype.positionPieces = function () {
            var p = this.findObjectsByType('p1')[0];
            this.pieces.push(new GGJ16.Puzzle5Piece(this, 'piece1puzzle', p.x + this.numPieceDimensions / 2, p.y + this.numPieceDimensions / 2, p.properties.xidx, p.properties.yidx));
            var p = this.findObjectsByType('p2')[0];
            this.pieces.push(new GGJ16.Puzzle5Piece(this, 'piece2puzzle', p.x + this.numPieceDimensions / 2, p.y + this.numPieceDimensions / 2, p.properties.xidx, p.properties.yidx));
            var p = this.findObjectsByType('p3')[0];
            this.pieces.push(new GGJ16.Puzzle5Piece(this, 'piece3puzzle', p.x + this.numPieceDimensions / 2, p.y + this.numPieceDimensions / 2, p.properties.xidx, p.properties.yidx));
            var p = this.findObjectsByType('p4')[0];
            this.pieces.push(new GGJ16.Puzzle5Piece(this, 'piece4puzzle', p.x + this.numPieceDimensions / 2, p.y + this.numPieceDimensions / 2, p.properties.xidx, p.properties.yidx));
            var p = this.findObjectsByType('p5')[0];
            this.pieces.push(new GGJ16.Puzzle5Piece(this, 'piece5puzzle', p.x + this.numPieceDimensions / 2, p.y + this.numPieceDimensions / 2, p.properties.xidx, p.properties.yidx));
            var p = this.findObjectsByType('p6')[0];
            this.pieces.push(new GGJ16.Puzzle5Piece(this, 'piece6puzzle', p.x + this.numPieceDimensions / 2, p.y + this.numPieceDimensions / 2, p.properties.xidx, p.properties.yidx));
            var p = this.findObjectsByType('p7')[0];
            this.pieces.push(new GGJ16.Puzzle5Piece(this, 'piece7puzzle', p.x + this.numPieceDimensions / 2, p.y + this.numPieceDimensions / 2, p.properties.xidx, p.properties.yidx));
            var p = this.findObjectsByType('p8')[0];
            this.pieces.push(new GGJ16.Puzzle5Piece(this, 'piece8puzzle', p.x + this.numPieceDimensions / 2, p.y + this.numPieceDimensions / 2, p.properties.xidx, p.properties.yidx));
            var n = this.findObjectsByType('note')[0];
            this.note = new Phaser.Sprite(this.game, n.x + n.width / 2, n.y + n.height / 2, 'noteBig');
            this.note.anchor.set(0.5);
            if (!GGJ16.DataManager.getInstance().piece1Placed &&
                !GGJ16.DataManager.getInstance().piece2Placed &&
                !GGJ16.DataManager.getInstance().piece3Placed) {
                this.pieces[0].alpha = 0.0;
                this.pieces[1].alpha = 0.0;
                this.pieces[2].alpha = 0.0;
            }
            else {
                if (GGJ16.DataManager.getInstance().note) {
                    this.game.add.tween(this.pieces[0]).to({ alpha: 1.0 }, 350, Phaser.Easing.Linear.None, true);
                    this.game.add.tween(this.pieces[1]).to({ alpha: 1.0 }, 350, Phaser.Easing.Linear.None, true);
                    this.game.add.tween(this.pieces[2]).to({ alpha: 1.0 }, 350, Phaser.Easing.Linear.None, true);
                    GGJ16.DataManager.getInstance().piece1Placed = true;
                    GGJ16.DataManager.getInstance().piece2Placed = true;
                    GGJ16.DataManager.getInstance().piece3Placed = true;
                    this.sfxPlacePiece.play();
                    GGJ16.DataManager.getInstance().piece1 = false;
                    GGJ16.DataManager.getInstance().piece2 = false;
                    GGJ16.DataManager.getInstance().piece3 = false;
                    this.minigameCanRun = true;
                    this.game.add.existing(this.note);
                    GGJ16.DataManager.getInstance().note = false;
                    GGJ16.DataManager.getInstance().notePlaced = true;
                }
                else if (GGJ16.DataManager.getInstance().notePlaced) {
                    this.game.add.tween(this.pieces[0]).to({ alpha: 1.0 }, 0, Phaser.Easing.Linear.None, true);
                    this.game.add.tween(this.pieces[1]).to({ alpha: 1.0 }, 0, Phaser.Easing.Linear.None, true);
                    this.game.add.tween(this.pieces[2]).to({ alpha: 1.0 }, 0, Phaser.Easing.Linear.None, true);
                    GGJ16.DataManager.getInstance().piece1Placed = true;
                    GGJ16.DataManager.getInstance().piece2Placed = true;
                    GGJ16.DataManager.getInstance().piece3Placed = true;
                    GGJ16.DataManager.getInstance().piece1 = false;
                    GGJ16.DataManager.getInstance().piece2 = false;
                    GGJ16.DataManager.getInstance().piece3 = false;
                    this.minigameCanRun = true;
                    this.game.add.existing(this.note);
                    GGJ16.DataManager.getInstance().note = false;
                    GGJ16.DataManager.getInstance().notePlaced = true;
                }
            }
        };
        Puzzle5.prototype.checkEndGame = function () {
            if (Number(this.pieces[0].xidx) == 0 && Number(this.pieces[0].yidx) == 0 &&
                Number(this.pieces[1].xidx) == 1 && Number(this.pieces[1].yidx) == 0 &&
                Number(this.pieces[2].xidx) == 2 && Number(this.pieces[2].yidx) == 0 &&
                Number(this.pieces[3].xidx) == 0 && Number(this.pieces[3].yidx) == 1 &&
                Number(this.pieces[4].xidx) == 1 && Number(this.pieces[4].yidx) == 1 &&
                Number(this.pieces[5].xidx) == 2 && Number(this.pieces[5].yidx) == 1 &&
                Number(this.pieces[6].xidx) == 0 && Number(this.pieces[6].yidx) == 2 &&
                Number(this.pieces[7].xidx) == 1 && Number(this.pieces[7].yidx) == 2) {
                //
                // TODO: End Game
                //
                this.pieceMoving = true;
                this.sfxSuccess.play();
                this.sfxScream.play();
                this.game.state.start('Outro', true, false);
            }
        };
        Puzzle5.prototype.findObjectsByType = function (type) {
            var objs = new Array();
            this.jsnLevel.objects['objects'].forEach(function (element) {
                if (element.name === type)
                    objs.push(element);
            });
            return objs;
        };
        return Puzzle5;
    })(Phaser.State);
    GGJ16.Puzzle5 = Puzzle5;
})(GGJ16 || (GGJ16 = {}));
/// <reference path="../../tsDefinitions/phaser.d.ts" />
/// <reference path="../../tsDefinitions/physicsType.d.ts" />
/// <reference path="../Monologue.ts" />
/// <reference path="../DataManager.ts" />
var GGJ16;
(function (GGJ16) {
    var Room1 = (function (_super) {
        __extends(Room1, _super);
        function Room1() {
            _super.apply(this, arguments);
        }
        //
        // NOTE: Phaser Standard Methods
        //
        Room1.prototype.create = function () {
            this.sfxLocked = this.game.add.audio('unlock');
            this.sfxOpen = this.game.add.audio('unlock');
            this.sfxSkull = this.game.add.audio('skullstatue');
            this.sfxRuby = this.game.add.audio('pickruby');
            this.sfxKey = this.game.add.audio('key');
            this.sfxSuccess = this.game.add.audio('success');
            this.sfxFootsteps = this.game.add.audio('footsteps', 1);
            this.finishedClickingSkull = this.finishedClickingTopDrawer = this.finishedClickingBottomDrawer = true;
            //Screen routines
            this.stage.backgroundColor = 0x222222;
            //Inventory
            this.inventory = new GGJ16.Inventory(this.game);
            //Init items sprites
            //Skull
            if (GGJ16.DataManager.getInstance().skullMouthOpen && !GGJ16.DataManager.getInstance().skullDone) {
                this.skull = new Phaser.Sprite(this.game, 0, 0, 'skullMouthOpenWithKey');
            }
            else if (GGJ16.DataManager.getInstance().skullDone) {
                this.skull = new Phaser.Sprite(this.game, 0, 0, 'skullMouthOpenNoKey');
            }
            else {
                this.skull = new Phaser.Sprite(this.game, 0, 0, 'skullMissingEye');
            }
            //Top Drawer
            if (GGJ16.DataManager.getInstance().topDrawerDone) {
                this.topDrawer = new Phaser.Sprite(this.game, 0, 0, 'topDrawerOpenNoPiece');
            }
            else if (GGJ16.DataManager.getInstance().topDrawerOpen) {
                this.topDrawer = new Phaser.Sprite(this.game, 0, 0, 'topDrawerOpenWithPiece');
            }
            else {
                this.topDrawer = new Phaser.Sprite(this.game, 0, 0, 'topDrawerClosed');
            }
            //Bottom Drawer
            if (GGJ16.DataManager.getInstance().bottomDrawerDone) {
                this.bottomDrawer = new Phaser.Sprite(this.game, 0, 0, 'bottomDrawerOpenNoRuby');
            }
            else if (GGJ16.DataManager.getInstance().bottomDrawerOpen) {
                this.bottomDrawer = new Phaser.Sprite(this.game, 0, 0, 'bottomDrawerOpenWithRuby');
            }
            else {
                this.bottomDrawer = new Phaser.Sprite(this.game, 0, 0, 'bottomDrawerClosed');
            }
            //Chest
            this.chest = new Phaser.Sprite(this.game, 0, 0, 'chest');
            //Map routines
            this.jsnMap = this.add.tilemap("room1JSON", 1200, 760, 1, 1);
            this.jsnMap.addTilesetImage('room1bg');
            this.jsnMap.createLayer('tiles').resizeWorld();
            this.createObjects();
            //Init Arrows
            this.leftArrow = new Phaser.Sprite(this.game, 40, this.game.world.centerY, 'arrowLeft');
            this.game.add.existing(this.leftArrow);
            this.leftArrow.anchor.set(0.5);
            this.leftArrow.inputEnabled = true;
            this.rightArrow = new Phaser.Sprite(this.game, this.game.world.width - 40, this.game.world.centerY, 'arrowRight');
            this.game.add.existing(this.rightArrow);
            this.rightArrow.anchor.set(0.5);
            this.rightArrow.inputEnabled = true;
            if (GGJ16.DataManager.getInstance().shouldShowInitialMessages) {
                GGJ16.DataManager.getInstance().canClick = false;
                new GGJ16.IntroMessage(this.game, "What happened? Where am I? Starving might not be a good option. I must escape this place! \n I should start by clicking stuff...");
            }
        };
        Room1.prototype.update = function () {
            var _this = this;
            //refresh inventory
            this.inventory.tick();
            //Show/Hide Room Change Arrows
            if (this.game.input.activePointer.position.x < 80) {
                this.leftArrow.alpha = 1.0;
            }
            else if (this.game.input.activePointer.position.x > this.game.world.width - 80) {
                this.rightArrow.alpha = 1.0;
            }
            else {
                this.leftArrow.alpha = this.rightArrow.alpha = 0.2;
            }
            //Control room change
            if (this.leftArrow.input.pointerDown(this.game.input.activePointer.id) && GGJ16.DataManager.getInstance().canClick) {
                console.log("change to room 3");
                this.game.state.start('Room3', true, false);
                this.sfxFootsteps.play();
            }
            else if (this.rightArrow.input.pointerDown(this.game.input.activePointer.id) && GGJ16.DataManager.getInstance().canClick) {
                console.log("change to room 2");
                this.game.state.start('Room2', true, false);
                this.sfxFootsteps.play();
            }
            if (this.chest.input.pointerDown(this.game.input.activePointer.id) && GGJ16.DataManager.getInstance().canClick) {
                console.log("change to room 5");
                this.game.state.start('Puzzle5', true, false);
                this.sfxFootsteps.play();
            }
            //Perfumarias com alpha
            if (this.chest.input.pointerOver(this.game.input.activePointer.id)) {
                this.chest.alpha = 1.0;
            }
            else {
                this.chest.alpha = 0.6;
            }
            if (this.skull.input.pointerOver(this.game.input.activePointer.id)) {
                this.skull.alpha = 1.0;
            }
            else {
                this.skull.alpha = 0.6;
            }
            if (this.bottomDrawer.input.pointerOver(this.game.input.activePointer.id)) {
                this.bottomDrawer.alpha = 1.0;
            }
            else {
                this.bottomDrawer.alpha = 0.6;
            }
            if (this.topDrawer.input.pointerOver(this.game.input.activePointer.id)) {
                this.topDrawer.alpha = 1.0;
            }
            else {
                this.topDrawer.alpha = 0.6;
            }
            //Skull
            if (this.finishedClickingSkull) {
                if (this.skull.input.pointerDown(this.game.input.activePointer.id) && GGJ16.DataManager.getInstance().canClick) {
                    this.finishedClickingSkull = false;
                    if (!GGJ16.DataManager.getInstance().ruby) {
                        if (!GGJ16.DataManager.getInstance().skullMouthOpen) {
                            new GGJ16.Monologue(this.game, "There is something inside... But I can't take it yet.");
                        }
                        else if (!GGJ16.DataManager.getInstance().skullDone) {
                            // console.log("Got the key");
                            this.skull.loadTexture('skullMouthOpenNoKey');
                            GGJ16.DataManager.getInstance().skullDone = true;
                            // DataManager.getInstance().keyDrawer = true;
                            this.sfxKey.play();
                            //create keyDrawer, interpolate to Inv
                            this.keyDrawer = new Phaser.Sprite(this.game, this.skull.position.x, this.skull.position.y, 'key');
                            this.keyDrawer.position.set(this.skull.position.x - this.keyDrawer.width / 2, this.skull.position.y - this.keyDrawer.height / 2);
                            this.game.add.existing(this.keyDrawer);
                            new GGJ16.Monologue(this.game, "Hmmm, a key...");
                            GGJ16.DataManager.getInstance().canClick = false;
                            var tween = this.game.add.tween(this.keyDrawer).to({ x: [0, this.keyDrawer.width + 10], y: [this.keyDrawer.position.y, 10] }, 1000, "Sine.easeInOut", true, 0, 0, false);
                            tween.interpolation(Phaser.Math.bezierInterpolation);
                            tween.onComplete.add(function () {
                                GGJ16.DataManager.getInstance().canClick = true;
                                GGJ16.DataManager.getInstance().keyDrawer = true;
                                _this.keyDrawer.destroy();
                            });
                        }
                    }
                    else {
                        if (!GGJ16.DataManager.getInstance().skullMouthOpen) {
                            this.sfxSkull.play();
                            this.skull.loadTexture('skullMouthOpenWithKey');
                            GGJ16.DataManager.getInstance().skullMouthOpen = true;
                            GGJ16.DataManager.getInstance().ruby = false;
                            new GGJ16.Monologue(this.game, "Ahhh, got it!");
                        }
                        else {
                            new GGJ16.Monologue(this.game, "It's empty.");
                        }
                    }
                }
            }
            else {
                if (this.skull.input.pointerUp(this.game.input.activePointer.id) && GGJ16.DataManager.getInstance().canClick) {
                    this.finishedClickingSkull = true;
                }
            }
            //BottomDrawer
            if (this.finishedClickingBottomDrawer) {
                if (this.bottomDrawer.input.pointerDown(this.game.input.activePointer.id) && GGJ16.DataManager.getInstance().canClick) {
                    this.finishedClickingBottomDrawer = false;
                    if (!GGJ16.DataManager.getInstance().bottomDrawerOpen) {
                        this.bottomDrawer.loadTexture('bottomDrawerOpenWithRuby');
                        this.bottomDrawer.position.set(this.bottomDrawer.position.x + 17, this.bottomDrawer.position.y - 7);
                        GGJ16.DataManager.getInstance().bottomDrawerOpen = true;
                        this.sfxOpen.play();
                    }
                    else if (!GGJ16.DataManager.getInstance().bottomDrawerDone) {
                        this.sfxRuby.play();
                        this.bottomDrawer.loadTexture('bottomDrawerOpenNoRuby');
                        GGJ16.DataManager.getInstance().bottomDrawerDone = true;
                        //create ruby, interpolate to Inv
                        this.ruby = new Phaser.Sprite(this.game, this.bottomDrawer.position.x, this.bottomDrawer.position.y, 'ruby');
                        this.ruby.position.set(this.bottomDrawer.position.x - this.ruby.width / 2, this.bottomDrawer.position.y - this.ruby.height / 2);
                        this.game.add.existing(this.ruby);
                        new GGJ16.Monologue(this.game, "A ruby. What should I do with it?");
                        GGJ16.DataManager.getInstance().canClick = false;
                        var tween = this.game.add.tween(this.ruby).to({ x: [0, this.ruby.width + 10], y: [this.ruby.position.y, 10] }, 1000, "Sine.easeInOut", true, 0, 0, false);
                        tween.interpolation(Phaser.Math.bezierInterpolation);
                        tween.onComplete.add(function () {
                            GGJ16.DataManager.getInstance().canClick = true;
                            GGJ16.DataManager.getInstance().ruby = true;
                            _this.ruby.destroy();
                        });
                    }
                    else {
                        new GGJ16.Monologue(this.game, "It's empty...");
                    }
                }
            }
            else {
                if (this.bottomDrawer.input.pointerUp(this.game.input.activePointer.id) && GGJ16.DataManager.getInstance().canClick) {
                    this.finishedClickingBottomDrawer = true;
                }
            }
            //TopDrawer
            if (this.finishedClickingTopDrawer) {
                if (this.topDrawer.input.pointerDown(this.game.input.activePointer.id) && GGJ16.DataManager.getInstance().canClick) {
                    this.finishedClickingTopDrawer = false;
                    if (!GGJ16.DataManager.getInstance().topDrawerOpen && GGJ16.DataManager.getInstance().keyDrawer) {
                        this.topDrawer.loadTexture('topDrawerOpenWithPiece');
                        this.topDrawer.position.set(this.topDrawer.position.x + 5, this.topDrawer.position.y + 5);
                        GGJ16.DataManager.getInstance().keyDrawer = false;
                        GGJ16.DataManager.getInstance().topDrawerOpen = true;
                        this.sfxOpen.play();
                    }
                    else if (!GGJ16.DataManager.getInstance().topDrawerOpen && !GGJ16.DataManager.getInstance().keyDrawer) {
                        new GGJ16.Monologue(this.game, "It's locked...");
                        this.sfxOpen.play();
                    }
                    else if (!GGJ16.DataManager.getInstance().topDrawerDone) {
                        this.topDrawer.loadTexture('topDrawerOpenNoPiece');
                        GGJ16.DataManager.getInstance().topDrawerDone = true;
                        //create piece1, interpolate to Inv
                        this.piece1 = new Phaser.Sprite(this.game, this.topDrawer.position.x, this.topDrawer.position.y, 'piece1puzzle64');
                        this.piece1.position.set(this.topDrawer.position.x - this.piece1.width / 2, this.topDrawer.position.y - this.piece1.height / 2);
                        this.game.add.existing(this.piece1);
                        new GGJ16.Monologue(this.game, "Hmmm, what is this?");
                        this.sfxSuccess.play();
                        GGJ16.DataManager.getInstance().canClick = false;
                        var tween = this.game.add.tween(this.piece1).to({ x: [0, this.piece1.width + 10], y: [this.piece1.position.y, 10] }, 1000, "Sine.easeInOut", true, 0, 0, false);
                        tween.interpolation(Phaser.Math.bezierInterpolation);
                        tween.onComplete.add(function () {
                            GGJ16.DataManager.getInstance().canClick = true;
                            GGJ16.DataManager.getInstance().piece1 = true;
                            _this.piece1.destroy();
                        });
                    }
                    else {
                        new GGJ16.Monologue(this.game, "It's empty...");
                    }
                }
            }
            else {
                if (this.topDrawer.input.pointerUp(this.game.input.activePointer.id)) {
                    this.finishedClickingTopDrawer = true;
                }
            }
        };
        //
        // NOTE: Custom Methods
        //
        Room1.prototype.findObjectsByType = function (type) {
            var objs = new Array();
            this.jsnMap.objects['objects'].forEach(function (element) {
                if (element.name === type)
                    objs.push(element);
            });
            return objs;
        };
        Room1.prototype.createObjects = function () {
            var _this = this;
            this.findObjectsByType('skull').forEach(function (element) {
                _this.skull.position.set(element.x + element.width / 2, element.y + element.height / 2);
                _this.game.add.existing(_this.skull);
                _this.skull.anchor.set(0.5);
                _this.skull.inputEnabled = true;
            }, this);
            this.findObjectsByType('topDrawer').forEach(function (element) {
                _this.topDrawer.position.set(element.x + element.width / 2, element.y + element.height / 2);
                _this.game.add.existing(_this.topDrawer);
                _this.topDrawer.anchor.set(0.5);
                _this.topDrawer.inputEnabled = true;
            }, this);
            this.findObjectsByType('bottomDrawer').forEach(function (element) {
                _this.bottomDrawer.position.set(element.x + element.width / 2, element.y + element.height / 2);
                _this.game.add.existing(_this.bottomDrawer);
                _this.bottomDrawer.anchor.set(0.5);
                _this.bottomDrawer.inputEnabled = true;
            }, this);
            this.findObjectsByType('chest').forEach(function (element) {
                _this.chest.position.set(element.x + element.width / 2, element.y + element.height / 2);
                _this.game.add.existing(_this.chest);
                _this.chest.anchor.set(0.5);
                _this.chest.inputEnabled = true;
            }, this);
        };
        return Room1;
    })(Phaser.State);
    GGJ16.Room1 = Room1;
})(GGJ16 || (GGJ16 = {}));
/// <reference path="../../tsDefinitions/phaser.d.ts" />
/// <reference path="../../tsDefinitions/physicsType.d.ts" />
/// <reference path="../Vial.ts" />
/// <reference path="../DataManager.ts" />
/// <reference path="../Monologue.ts" />
var GGJ16;
(function (GGJ16) {
    var Room2 = (function (_super) {
        __extends(Room2, _super);
        function Room2() {
            _super.apply(this, arguments);
        }
        //
        // NOTE: Phaser Standard Methods
        //
        Room2.prototype.create = function () {
            var _this = this;
            //Screen routines
            this.stage.backgroundColor = 0x222222;
            this.holdingVial = false;
            this.vialBeingHeld = null;
            this.inventory = new GGJ16.Inventory(this.game);
            //Sound
            this.sfxPickVial = this.game.add.audio('pickvial');
            this.sfxFillVial = this.game.add.audio('fillvial');
            this.sfxOpenLocker = this.game.add.audio('openlocker');
            this.sfxPickPaper = this.game.add.audio('pickpaper');
            this.sfxUnlock = this.game.add.audio('unlock');
            this.sfxSuccess = this.game.add.audio('success');
            this.sfxFootstep = this.game.add.audio('footsteps');
            //Init Arrays
            this.arrayVials = new Array();
            //Map routines
            this.jsnMap = this.add.tilemap("room2JSON", 1200, 760, 1, 1);
            this.jsnMap.addTilesetImage('room2bg');
            this.jsnMap.createLayer('tiles').resizeWorld();
            this.createObjects();
            if (GGJ16.DataManager.getInstance().showPieceMonologue) {
                this.sfxSuccess.play();
                new GGJ16.Monologue(this.game, "Another piece, and a strange note...");
                GGJ16.DataManager.getInstance().showPieceMonologue = false;
                this.sfxPickPaper.play();
                this.sfxOpenLocker.play();
                //piece2 and note
                this.piece2 = new Phaser.Sprite(this.game, this.locker.position.x, this.locker.position.y, 'piece2puzzle64');
                this.piece2.position.set(this.locker.position.x - this.piece2.width / 2, this.locker.position.y - this.piece2.height / 2);
                this.game.add.existing(this.piece2);
                // new Monologue(this.game, "Hmmm, what is this?");
                GGJ16.DataManager.getInstance().canClick = false;
                var tween = this.game.add.tween(this.piece2).to({ x: [0, this.piece2.width + 10], y: [this.piece2.position.y, 10] }, 1000, "Sine.easeInOut", true, 0, 0, false);
                tween.interpolation(Phaser.Math.bezierInterpolation);
                tween.onComplete.add(function () {
                    GGJ16.DataManager.getInstance().canClick = true;
                    GGJ16.DataManager.getInstance().piece2 = true;
                    _this.piece2.destroy();
                    _this.note = new Phaser.Sprite(_this.game, _this.locker.position.x, _this.locker.position.y, 'note');
                    _this.note.position.set(_this.locker.position.x - _this.note.width / 2, _this.locker.position.y - _this.note.height / 2);
                    _this.game.add.existing(_this.note);
                    // new Monologue(this.game, "Hmmm, what is this?");
                    GGJ16.DataManager.getInstance().canClick = false;
                    var tween = _this.game.add.tween(_this.note).to({ x: [0, _this.note.width + 10], y: [_this.note.position.y, 10] }, 1000, "Sine.easeInOut", true, 0, 0, false);
                    tween.interpolation(Phaser.Math.bezierInterpolation);
                    tween.onComplete.add(function () {
                        GGJ16.DataManager.getInstance().canClick = true;
                        GGJ16.DataManager.getInstance().note = true;
                        _this.note.destroy();
                    });
                });
            }
            //Init Arrows
            this.leftArrow = new Phaser.Sprite(this.game, 40, this.game.world.centerY, 'arrowLeft');
            this.game.add.existing(this.leftArrow);
            this.leftArrow.anchor.set(0.5);
            this.leftArrow.inputEnabled = true;
            this.rightArrow = new Phaser.Sprite(this.game, this.game.world.width - 40, this.game.world.centerY, 'arrowRight');
            this.game.add.existing(this.rightArrow);
            this.rightArrow.anchor.set(0.5);
            this.rightArrow.inputEnabled = true;
        };
        Room2.prototype.update = function () {
            var _this = this;
            this.inventory.tick();
            //Show/Hide Room Change Arrows
            if (this.game.input.activePointer.position.x < 80) {
                this.leftArrow.alpha = 1.0;
            }
            else if (this.game.input.activePointer.position.x > this.game.world.width - 80) {
                this.rightArrow.alpha = 1.0;
            }
            else {
                this.leftArrow.alpha = this.rightArrow.alpha = 0.2;
            }
            //Control room change
            if (this.leftArrow.input.pointerDown(this.game.input.activePointer.id) && GGJ16.DataManager.getInstance().canClick) {
                this.game.state.start('Room1', true, false);
                this.sfxFootstep.play();
            }
            else if (this.rightArrow.input.pointerDown(this.game.input.activePointer.id) && GGJ16.DataManager.getInstance().canClick) {
                console.log("change to room 3");
                this.sfxFootstep.play();
                this.game.state.start('Room3', true, false);
            }
            //Control Vials...
            this.arrayVials.forEach(function (vial) {
                if (vial.input.pointerOver(_this.game.input.activePointer.id) || vial === _this.vialBeingHeld) {
                    vial.alpha = 1.0;
                }
                else if (vial.colorState < 6 || vial.colorState === vialState.empty || vial.colorState === vialState.emptyUnusable) {
                    vial.alpha = 0.5;
                }
                if (vial.input.pointerDown(_this.game.input.activePointer.id)) {
                    if (vial.colorState < 6) {
                        _this.sfxPickVial.play();
                        _this.vialBeingHeld = vial;
                        _this.holdingVial = true;
                    }
                    else if (vial.colorState === vialState.empty && _this.holdingVial) {
                        vial.setNewColor(_this.vialBeingHeld.colorState);
                        _this.sfxFillVial.play();
                        _this.vialBeingHeld.useThePaint();
                        _this.vialBeingHeld = null;
                        _this.holdingVial = false;
                    }
                    else if ((vial.colorState === vialState.hRedResult ||
                        vial.colorState === vialState.hGreenResult ||
                        vial.colorState === vialState.hBlueResult) && _this.holdingVial) {
                        if (vial.colorState === _this.vialBeingHeld.colorState + 3) {
                            _this.sfxPickVial.play();
                            new GGJ16.Monologue(_this.game, "There's no use in using the same color twice...");
                            _this.vialBeingHeld = null;
                            _this.holdingVial = false;
                            return;
                        }
                        else {
                            if (vial.mixColor(_this.vialBeingHeld.colorState)) {
                                console.log("Mixed successfuly");
                                _this.sfxFillVial.play();
                                _this.vialBeingHeld.useThePaint();
                                _this.vialBeingHeld = null;
                                _this.holdingVial = false;
                            }
                        }
                    }
                }
            });
        };
        //
        // NOTE: Custom Methods
        //
        Room2.prototype.findObjectsByType = function (type) {
            var objs = new Array();
            this.jsnMap.objects['objects'].forEach(function (element) {
                if (element.name === type)
                    objs.push(element);
            });
            return objs;
        };
        Room2.prototype.createObjects = function () {
            var _this = this;
            this.findObjectsByType('vialR').forEach(function (element) {
                _this.arrayVials.push(new GGJ16.Vial(_this.game, element.x + element.width / 2, element.y + element.height / 2, vialState.red, 0));
            }, this);
            this.findObjectsByType('vialG').forEach(function (element) {
                _this.arrayVials.push(new GGJ16.Vial(_this.game, element.x + element.width / 2, element.y + element.height / 2, vialState.green, 0));
            }, this);
            this.findObjectsByType('vialB').forEach(function (element) {
                _this.arrayVials.push(new GGJ16.Vial(_this.game, element.x + element.width / 2, element.y + element.height / 2, vialState.blue, 0));
            }, this);
            this.findObjectsByType('vial1').forEach(function (element) {
                _this.arrayVials.push(new GGJ16.Vial(_this.game, element.x + element.width / 2, element.y + element.height / 2, vialState.empty, 1));
            }, this);
            this.findObjectsByType('vial2').forEach(function (element) {
                _this.arrayVials.push(new GGJ16.Vial(_this.game, element.x + element.width / 2, element.y + element.height / 2, vialState.empty, 2));
            }, this);
            this.findObjectsByType('vial3').forEach(function (element) {
                _this.arrayVials.push(new GGJ16.Vial(_this.game, element.x + element.width / 2, element.y + element.height / 2, vialState.empty, 3));
            }, this);
            this.findObjectsByType('locker').forEach(function (element) {
                if (GGJ16.DataManager.getInstance().lockerDone) {
                    _this.locker = new Phaser.Sprite(_this.game, element.x + element.width / 2, element.y + element.height / 2, 'lockerOpen');
                }
                else {
                    _this.locker = new Phaser.Sprite(_this.game, element.x + element.width / 2, element.y + element.height / 2, 'locker');
                }
                _this.locker.alpha = 0.7;
                _this.locker.anchor.set(0.5);
                _this.locker.bringToTop();
                _this.game.add.existing(_this.locker);
                _this.locker.inputEnabled = true;
                _this.locker.events.onInputDown.add(_this.lockerClicked, _this);
                _this.locker.events.onInputOver.add(_this.lockerOver, _this);
                _this.locker.events.onInputOut.add(_this.lockerOut, _this);
            }, this);
        };
        Room2.prototype.lockerOver = function () {
            this.locker.alpha = 1.0;
        };
        Room2.prototype.lockerOut = function () {
            this.locker.alpha = 0.7;
        };
        Room2.prototype.lockerClicked = function () {
            if (!GGJ16.DataManager.getInstance().lockerDone && GGJ16.DataManager.getInstance().canClick) {
                this.game.state.start('Puzzle4', true, false);
                this.sfxUnlock.play();
            }
        };
        return Room2;
    })(Phaser.State);
    GGJ16.Room2 = Room2;
})(GGJ16 || (GGJ16 = {}));
/// <reference path="../../tsDefinitions/phaser.d.ts" />
/// <reference path="../DataManager.ts" />
/// <reference path="../Monologue.ts" />
/// <reference path="../Puzzle4Button.ts" />
var GGJ16;
(function (GGJ16) {
    var Room3 = (function (_super) {
        __extends(Room3, _super);
        function Room3() {
            _super.apply(this, arguments);
        }
        //
        // NOTE: Phaser Standard Methods
        //
        Room3.prototype.create = function () {
            //Local vars
            this.stage.backgroundColor = 0x222222;
            this.clickedLastFrame = false;
            this.sfxFootsteps = this.game.add.audio('footsteps');
            this.sfxUnlock = this.game.add.audio('unlock');
            //Map routines
            this.jsnLevel = this.add.tilemap('room3jsn', 1200, 760, 1, 1);
            this.jsnLevel.addTilesetImage('room3bg');
            this.jsnLevel.createLayer('tiles').resizeWorld();
            //Init Arrows
            this.leftArrow = new Phaser.Sprite(this.game, 40, this.game.world.centerY, 'arrowLeft');
            this.game.add.existing(this.leftArrow);
            this.leftArrow.anchor.set(0.5);
            this.leftArrow.inputEnabled = true;
            this.rightArrow = new Phaser.Sprite(this.game, this.game.world.width - 40, this.game.world.centerY, 'arrowRight');
            this.game.add.existing(this.rightArrow);
            this.rightArrow.anchor.set(0.5);
            this.rightArrow.inputEnabled = true;
            this.inventory = new GGJ16.Inventory(this.game);
            var p = this.findObjectsByType('statue')[0];
            if (GGJ16.DataManager.getInstance().puzzle3Done)
                this.statue = this.game.add.sprite(p.x + p.width / 2, p.y + p.height / 2, 'statueSolved');
            else
                this.statue = this.game.add.sprite(p.x + p.width / 2, p.y + p.height / 2, 'statueClosed');
            this.statue.anchor.set(0.5);
            this.statue.alpha = 0.7;
            this.statue.inputEnabled = true;
            this.statue.events.onInputDown.add(this.handleClick, this);
            this.statue.events.onInputOver.add(this.handleOver, this);
            this.statue.events.onInputOut.add(this.handleOut, this);
        };
        Room3.prototype.update = function () {
            this.inventory.tick();
            //Show/Hide Room Change Arrows
            if (this.game.input.activePointer.position.x < 80) {
                this.leftArrow.alpha = 1.0;
            }
            else if (this.game.input.activePointer.position.x > this.game.world.width - 80) {
                this.rightArrow.alpha = 1.0;
            }
            else {
                this.leftArrow.alpha = this.rightArrow.alpha = 0.2;
            }
            //Control room change
            if (this.leftArrow.input.pointerDown(this.game.input.activePointer.id) && GGJ16.DataManager.getInstance().canClick) {
                console.log("change to room 2");
                this.sfxFootsteps.play();
                this.game.state.start('Room2', true, false);
            }
            else if (this.rightArrow.input.pointerDown(this.game.input.activePointer.id) && GGJ16.DataManager.getInstance().canClick) {
                console.log("change to room 1");
                this.sfxFootsteps.play();
                this.game.state.start('Room1', true, false);
            }
        };
        //
        // NOTE: Custom Methods
        //
        Room3.prototype.handleClick = function () {
            //
            // TODO: Go to the 3 vials puzzle
            //
            if (GGJ16.DataManager.getInstance().canClick) {
                this.sfxUnlock.play();
                this.game.state.start('Puzzle3', true, false);
            }
        };
        Room3.prototype.handleOver = function () {
            this.statue.alpha = 1.0;
        };
        Room3.prototype.handleOut = function () {
            this.statue.alpha = 0.7;
        };
        Room3.prototype.findObjectsByType = function (type) {
            var objs = new Array();
            this.jsnLevel.objects['objects'].forEach(function (element) {
                if (element.name === type)
                    objs.push(element);
            });
            return objs;
        };
        return Room3;
    })(Phaser.State);
    GGJ16.Room3 = Room3;
})(GGJ16 || (GGJ16 = {}));
