enum vialState
{
    red, 
    green, 
    blue, 
    hRed, 
    hGreen, 
    hBlue, 
    hRedResult, 
    hGreenResult, 
    hBlueResult,
    yellow,
    cyan,
    magenta,
    empty,
    emptyUnusable,
    invisible
};

module GGJ16 {
    
    export class DataManager {
    
        private static _instance:DataManager = new DataManager();
        
        public canClick:boolean;
        public shouldShowInitialMessages:boolean;
    
        //
        // NOTE: Inventory
        //
        public piece1:boolean;
        public piece2:boolean;
        public piece3:boolean;
        public vialY:boolean;
        public vialC:boolean;
        public vialM:boolean;
        public ruby:boolean;
        public keyDrawer:boolean;
        public note:boolean;
        public notePlaced:boolean;
        
        //
        // NOTE: Puzzle1
        //
        public topDrawerOpen:boolean;
        public topDrawerDone:boolean;
        public bottomDrawerOpen:boolean;
        public bottomDrawerDone:boolean;
        public skullDone:boolean;
        public skullMouthOpen:boolean;
        
        //
        // NOTE: Puzzle2 
        //
        public vialRStatus:vialState;
        public vialGStatus:vialState;
        public vialBStatus:vialState;
        public vialYStatus:vialState;
        public vialCStatus:vialState;
        public vialMStatus:vialState;
        public vial1Status:vialState;
        public vial2Status:vialState;
        public vial3Status:vialState;
        public vial1Presence:boolean;
        public vial2Presence:boolean;
        public vial3Presence:boolean;
        
        //
        // NOTE: Puzzle3
        //
        public vial1Placement:boolean;
        public vial2Placement:boolean;
        public vial3Placement:boolean;
        public puzzle3Done:boolean;
        
        //
        // NOTE: Puzzle4
        //
        public lockerOpen:boolean;
        public lockerDone:boolean;
        public showPieceMonologue:boolean;
        
        //
        // NOTE: Puzzle5
        //
        public piece1Placed:boolean;
        public piece2Placed:boolean;
        public piece3Placed:boolean;
        
        //
        // NOTE: Constructor
        //
        constructor() {
            if(DataManager._instance){
                throw new Error("Error: Instantiation failed: Use SingletonDemo.getInstance() instead of new.");
            }
            
            DataManager._instance = this;
            this.initValues();
        }
        
        //
        // NOTE: Init Values
        //
        initValues() {
            
            this.canClick = true;
            
            this.shouldShowInitialMessages = true;
            
            //
            // NOTE: Inventory
            //
            this.piece1 = false;
            this.piece2 = false;
            this.piece3 = false;
            this.vialY = false;
            this.vialC = false;
            this.vialM = false;
            this.ruby = false;
            this.keyDrawer = false;
            this.note = false;
            this.notePlaced = false;

            //
            // NOTE: Puzzle1
            //
            this.topDrawerDone = false;
            this.topDrawerOpen = false;
            this.bottomDrawerDone = false;
            this.bottomDrawerOpen = false;
            this.skullDone = false;
            this.skullMouthOpen = false;

            //
            // NOTE: Puzzle2 
            //
            this.vialRStatus = vialState.red;
            this.vialGStatus = vialState.green;
            this.vialBStatus = vialState.blue;
            this.vialYStatus = vialState.empty;
            this.vialCStatus = vialState.empty;
            this.vialMStatus = vialState.empty;
            this.vial1Presence = true;
            this.vial2Presence = true;
            this.vial3Presence = true;
            this.vial1Status = vialState.empty;
            this.vial2Status = vialState.empty;
            this.vial3Status = vialState.empty;

            //
            // NOTE: Puzzle3
            //
            this.vial1Placement = false;
            this.vial2Placement = false;
            this.vial3Placement = false;
            this.puzzle3Done = false;

            //
            // NOTE: Puzzle4
            //
            this.lockerOpen = false;
            this.lockerDone = false;
            this.showPieceMonologue = false;

            //
            // NOTE: Puzzle5
            //
            this.piece1Placed = false;
            this.piece2Placed = false;
            this.piece3Placed = false;
            
        }
        
        public static getInstance():DataManager
        {
            return DataManager._instance;
        } 
    }
    
}