/// <reference path="../tsDefinitions/phaser.d.ts" />
/// <reference path="./DataManager.ts" />

module GGJ16 {
    
    
    export class Monologue extends Phaser.Text {
        g: Phaser.Game;
        
        constructor(g: Phaser.Game, message: string) 
        {
            this.g = g;
            super(this.g, 0, 0, message);
            var style = { font: "24px Arial", fill: "#ffffff", align: "center" };
            this.setStyle(style);
            this.position.set(this.g.world.centerX, this.g.world.height - 40);
            this.anchor.set(0.5);
            this.alpha = 0.0;
            this.animate();
            this.g.add.existing(this);
        }
        
        animate()
        {
            var fadeOut: Phaser.Tween;
            var fadeIn: Phaser.Tween = this.g.add.tween(this).to({alpha:1.0}, 500, Phaser.Easing.Linear.None, true);
            fadeIn.onComplete.add( () => {fadeOut = this.g.add.tween(this).to({alpha: 0.0}, 2500, Phaser.Easing.Linear.None, true, 250);
                fadeOut.onComplete.add( () => {this.destroy()});
            }, this);
            
        }
    }
}