/// <reference path="../tsDefinitions/phaser.d.ts" />

module GGJ16 {
    
    export class Puzzle4Button extends Phaser.Sprite {

        idx:number;
        p4: Puzzle4;
        state: number;
        
        constructor(p4: Puzzle4, identifier:string, x:number, y:number, idx:number) {
            
            super(p4.game, x, y, identifier);
            this.alpha = 0.6;
            this.anchor.set(0.5);
            p4.game.add.existing(this);
            this.idx = idx;
            this.inputEnabled = true;
            this.p4 = p4;
            this.events.onInputDown.add(this.handleClick, this);
            this.events.onInputOver.add(this.handleOver, this);
            this.events.onInputOut.add(this.handleOut, this);
            this.state = 0;
            
        }
        
        handleOver()
        {
            this.alpha = 1.0;
        }
        
        handleOut()
        {
            this.alpha = 0.6;
        }
        
        handleClick() 
        {
            if(!DataManager.getInstance().canClick)
            {
                return;
            }
            
            if(!DataManager.getInstance().puzzle3Done)
            {
                new Monologue(this.game, "Even if I tried, I wouldn't know what to do... yet...");
                return;
            }
            
            if( Number(this.idx) == Number(this.p4.nextIdx)) 
            {
                // this.p3.sfxPressButton.play();
                this.p4.countProgress = Number(this.p4.countProgress) + 1;
                this.state = 1;
                this.loadTexture('dbtn');
                this.p4.nextIdx = this.p4.sequence[this.p4.countProgress];
                this.p4.sfxGrab.play();
                if( this.p4.countProgress == this.p4.sequence.length ) {
                    DataManager.getInstance().lockerOpen = true;
                    
                }
                
            }
            else
            {
                this.p4.resetButtons();
                this.p4.sfxGrab.play();
            }
        }
        
    }
}