/// <reference path="../../tsDefinitions/phaser.d.ts" />

module GGJ16 {
    export class Intro extends Phaser.State {
        
        screens: Array<Phaser.Sprite>;
        fadeInTime: number;
        stayTime: number;
        fadeOutTime: number;
        skipKey: Phaser.Key;
        nextKey: Phaser.Key;
        countProgress: number;
        
        preload() {
            
        }
 
        create() {
            this.skipKey = this.input.keyboard.addKey(Phaser.Keyboard.ENTER);
            this.nextKey = this.input.keyboard.addKey(Phaser.Keyboard.SPACEBAR);
            this.countProgress = 0;
            this.screens = new Array<Phaser.Sprite>();
		    this.screens.push(this.game.add.sprite(0, 0, 'intro1'));
            this.screens.push(this.game.add.sprite(0, 0, 'intro2'));
            this.screens.push(this.game.add.sprite(0, 0, 'intro3'));
            this.screens.push(this.game.add.sprite(0, 0, 'intro4'));
            this.screens.push(this.game.add.sprite(0, 0, 'intro5'));
            this.screens.push(this.game.add.sprite(0, 0, 'intro6'));
            this.screens.push(this.game.add.sprite(0, 0, 'intro7'));
            this.screens.push(this.game.add.sprite(0, 0, 'intro8'));
            this.screens.push(this.game.add.sprite(0, 0, 'intro9'));
            
            for( var i = 0; i < this.screens.length; i++ )
                this.screens[i].alpha = 0.0;
            
            this.stage.backgroundColor = 0x000000;
            
            this.fadeInTime = 800;
            this.stayTime = 5000;
            this.fadeOutTime = 350;
            
            this.loadIntro1();
               
        }
        
        update() {
            if (this.skipKey.justDown) {
                this.game.tweens.removeAll();
                this.game.state.start('Room1', true, false);
            }
            if(this.nextKey.justDown) {
                
                this.game.tweens.removeAll();
                this.zeroAlphaAllScreens();
                
                switch (this.countProgress) {
                    case 0:
                        this.loadIntro2();
                        break;
                    case 1:
                        this.loadIntro3();
                        break;
                    case 2:
                        this.loadIntro4();
                        break;
                    case 3:
                        this.loadIntro5();
                        break;
                    case 4:
                        this.loadIntro6();
                        break;
                    case 5:
                        this.loadIntro7();
                        break;
                    case 6:
                        this.loadIntro8();
                        break;
                    case 7:
                        this.loadIntro9();
                        break;
                    case 8:
                        this.game.tweens.removeAll();
                        this.game.state.start('Room1', true, false);
                        break;
                }
            }
        }
        
        zeroAlphaAllScreens() {
            for( var i = 0; i < this.screens.length; i++)
                this.screens[i].alpha = 0.0;
        }
        
        loadIntro1() {
            this.game.add.tween(this.screens[0]).to({alpha: 1.0}, this.fadeInTime, Phaser.Easing.Linear.None, true);//.onComplete.add(this.unloadIntro1, this);
        }   
        unloadIntro1() {
            this.game.add.tween(this.screens[0]).to({alpha: 0.0}, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro2, this);
        }
        loadIntro2() {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[1]).to({alpha: 1.0}, this.fadeInTime, Phaser.Easing.Linear.None, true);//.onComplete.add(this.unloadIntro2, this);
        }
        unloadIntro2() {
            this.game.add.tween(this.screens[1]).to({alpha: 0.0}, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro3, this);
        }
        loadIntro3() {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[2]).to({alpha: 1.0}, this.fadeInTime, Phaser.Easing.Linear.None, true);//.onComplete.add(this.unloadIntro3, this);
        }
        unloadIntro3() {
            this.game.add.tween(this.screens[2]).to({alpha: 0.0}, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro4, this);
        }
        loadIntro4() {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[3]).to({alpha: 1.0}, this.fadeInTime, Phaser.Easing.Linear.None, true);//.onComplete.add(this.unloadIntro4, this);
        }
        unloadIntro4() {
            this.game.add.tween(this.screens[3]).to({alpha: 0.0}, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro5, this);
        }
        loadIntro5() {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[4]).to({alpha: 1.0}, this.fadeInTime, Phaser.Easing.Linear.None, true);//.onComplete.add(this.unloadIntro5, this);
        }
        unloadIntro5() {
            this.game.add.tween(this.screens[4]).to({alpha: 0.0}, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro6, this);
        }
        loadIntro6() {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[5]).to({alpha: 1.0}, this.fadeInTime, Phaser.Easing.Linear.None, true);//.onComplete.add(this.unloadIntro6, this);
        }
        unloadIntro6() {
            this.game.add.tween(this.screens[5]).to({alpha: 0.0}, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro7, this);
        }
        loadIntro7() {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[6]).to({alpha: 1.0}, this.fadeInTime, Phaser.Easing.Linear.None, true);//.onComplete.add(this.unloadIntro7, this);
        }
        unloadIntro7() {
            this.game.add.tween(this.screens[6]).to({alpha: 0.0}, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro8, this);
        }
        loadIntro8() {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[7]).to({alpha: 1.0}, this.fadeInTime, Phaser.Easing.Linear.None, true);//.onComplete.add(this.unloadIntro8, this);
        }
        unloadIntro8() {
            this.game.add.tween(this.screens[7]).to({alpha: 0.0}, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro9, this);
        }
        loadIntro9() {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[8]).to({alpha: 1.0}, this.fadeInTime, Phaser.Easing.Linear.None, true);//.onComplete.add(this.unloadIntro9, this);
        }
        unloadIntro9() {
            this.game.add.tween(this.screens[8]).to({alpha: 0.0}, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.goToGame, this);
        }
        
        goToGame() {
            this.game.state.start('Room1', true, false, true);
        }

        
        // showMainMenu()
        // {
        //     this.game.state.start("MainMenu");
        // }
        
    }
}