/// <reference path="../../tsDefinitions/phaser.d.ts" />

module GGJ16 {
    export class MainMenu extends Phaser.State {
        
        preload() {
            
        }
 
        create() {
            DataManager.getInstance().initValues();
            var buttonCredits = this.game.add.button(this.game.width*0.5, this.game.height*0.75, 'buttonCredits', this.showCredits, this, 2, 1, 0);
            buttonCredits.anchor.set(0.5);

            buttonCredits.onInputOver.add(this.creditsOver, this);
            buttonCredits.onInputOut.add(this.creditsOut, this);
            buttonCredits.onInputUp.add(this.up, this);

            var buttonPlay  = this.game.add.button(this.game.width/2, this.game.height*0.6, 'buttonPlay', this.playTheGame, this);
            buttonPlay.anchor.set(0.5);
            
            var mainMenuImage = this.game.add.sprite(this.game.width/2, this.game.height/2, 'mainMenuImage');
            mainMenuImage.anchor.set(0.5);
            mainMenuImage.sendToBack();
            
            var gameTitle = this.game.add.sprite(this.game.width/2, this.game.height*0.3, 'gameTitle');
            gameTitle.anchor.set(0.5);
            gameTitle.bringToTop();

        }
        
        up() {
            console.log('button up', arguments);
        }

        creditsOver() {
            console.log('button over');
        }

        creditsOut() {
            console.log('button out');
        }

        playTheGame()
        {   
            this.game.state.start("Intro");
        }

        showCredits()
        {
            this.game.state.start("Credits");
        }
        
    }
}