/// <reference path="../../tsDefinitions/phaser.d.ts" />

module GGJ16 {
    export class Outro extends Phaser.State {
        
        screens: Array<Phaser.Sprite>;
        fadeInTime: number;
        stayTime: number;
        fadeOutTime: number;
        skipKey: Phaser.Key;
        nextKey: Phaser.Key;
        countProgress: number;
        
        preload() {
            
        }
 
        create() {
            this.skipKey = this.input.keyboard.addKey(Phaser.Keyboard.ENTER);
            this.nextKey = this.input.keyboard.addKey(Phaser.Keyboard.SPACEBAR);
            this.countProgress = 0;
            this.screens = new Array<Phaser.Sprite>();
		    this.screens.push(this.game.add.sprite(0, 0, 'outro1'));
            this.screens.push(this.game.add.sprite(0, 0, 'outro2'));
            this.screens.push(this.game.add.sprite(0, 0, 'outro3'));
            this.screens.push(this.game.add.sprite(0, 0, 'outro4'));
            this.screens.push(this.game.add.sprite(0, 0, 'outro5'));
            
            for( var i = 0; i < this.screens.length; i++ )
                this.screens[i].alpha = 0.0;
            
            this.stage.backgroundColor = 0x000000;
            
            this.fadeInTime = 500;
            this.stayTime = 5000;
            this.fadeOutTime = 450;
            
            this.loadIntro1();
               
        }
        
        update() {
            if (this.skipKey.justDown) {
                this.game.tweens.removeAll();
                this.game.state.start('MainMenu', true, false);
            }
            if(this.nextKey.justDown) {
                
                this.game.tweens.removeAll();
                this.zeroAlphaAllScreens();
                
                switch (this.countProgress) {
                    case 0:
                        this.loadIntro2();
                        break;
                    case 1:
                        this.loadIntro3();
                        break;
                    case 2:
                        this.loadIntro4();
                        break;
                    case 3:
                        this.loadIntro5();
                        break;
                    case 4:
                        this.game.tweens.removeAll();
                        this.game.state.start('MainMenu', true, false);
                        break;
                }
            }
        }
        
        zeroAlphaAllScreens() {
            for( var i = 0; i < this.screens.length; i++)
                this.screens[i].alpha = 0.0;
        }
        
        loadIntro1() {
            this.game.add.tween(this.screens[0]).to({alpha: 1.0}, this.fadeInTime, Phaser.Easing.Linear.None, true);//.onComplete.add(this.unloadIntro1, this);
        }   
        unloadIntro1() {
            this.game.add.tween(this.screens[0]).to({alpha: 0.0}, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro2, this);
        }
        loadIntro2() {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[1]).to({alpha: 1.0}, this.fadeInTime, Phaser.Easing.Linear.None, true);//.onComplete.add(this.unloadIntro2, this);
        }
        unloadIntro2() {
            this.game.add.tween(this.screens[1]).to({alpha: 0.0}, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro3, this);
        }
        loadIntro3() {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[2]).to({alpha: 1.0}, this.fadeInTime, Phaser.Easing.Linear.None, true);//.onComplete.add(this.unloadIntro3, this);
        }
        unloadIntro3() {
            this.game.add.tween(this.screens[2]).to({alpha: 0.0}, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro4, this);
        }
        loadIntro4() {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[3]).to({alpha: 1.0}, this.fadeInTime, Phaser.Easing.Linear.None, true);//.onComplete.add(this.unloadIntro4, this);
        }
        unloadIntro4() {
            this.game.add.tween(this.screens[3]).to({alpha: 0.0}, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.loadIntro5, this);
        }
        loadIntro5() {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[4]).to({alpha: 1.0}, this.fadeInTime, Phaser.Easing.Linear.None, true);//.onComplete.add(this.unloadIntro5, this);
        }
        unloadIntro5() {
            this.countProgress = Number(this.countProgress) + 1;
            this.game.add.tween(this.screens[4]).to({alpha: 0.0}, this.fadeOutTime, Phaser.Easing.Linear.None, true, this.stayTime).onComplete.add(this.goToEnd, this);
        }
        
        goToEnd() {
            DataManager.getInstance().initValues();
            this.game.state.start('MainMenu', true, false);
        }

        
        // showMainMenu()
        // {
        //     this.game.state.start("MainMenu");
        // }
        
    }
}