/// <reference path="../../tsDefinitions/phaser.d.ts" />
/// <reference path="../Main.ts" />
module GGJ16 {
    export class Preload extends Phaser.State {
 
        animLoading: Phaser.Sprite;
 
        preload() { 
            this.animLoading = this.add.sprite(this.world.centerX, this.world.centerY, 'animLoading', 0);
            this.animLoading.anchor.set(0.5,0.5);
            this.animLoading.animations.add('loading');
            this.animLoading.animations.play('loading', 8, true);
            
            this.load.bitmapFont('chillerBlack','assets/other/chillerBlack.png', 'assets/other/chillerBlack.fnt');
            
            this.load.tilemap('room1JSON', 'assets/json/room1.json', null, Phaser.Tilemap.TILED_JSON);
            this.load.tilemap('room2JSON', 'assets/json/room2.json', null, Phaser.Tilemap.TILED_JSON);
            // this.load.image('atlas', 'assets/img/atlas.png');
            // this.load.image('roundy', 'assets/img/roundy.png');
            // this.load.image('star', 'assets/img/star.png');
            // this.load.audio('bgmusic', ['assets/music/bgmusic.mp3', 'assets/music/bgmusic.ogg']);
            // this.load.audio('jump', ['assets/sfx/jump.wav', 'assets/sfx/jump.ogg']);
            
            //buttons
            this.game.load.spritesheet('buttonCredits', 'assets/img/btnCredits.png', 259, 109);
            this.game.load.spritesheet('buttonBack',    'assets/img/buttonBack.png',    163, 77);
            this.game.load.image('buttonPlay',          'assets/img/btnPlay.png');
            this.game.load.image('menuCredits',         'assets/img/menuCredits.png');
            this.game.load.image('mainMenuImage',       'assets/img/menubg.png');
            this.game.load.image('gameTitle',       'assets/img/gameTitle.png');
            
            //Puzzle 2
            this.game.load.image('vialRedFull',         'assets/img/vialRedFull.png');
            this.game.load.image('vialRedHalf',         'assets/img/vialRedHalf.png');
            this.game.load.image('vialGreenFull',       'assets/img/vialGreenFull.png');
            this.game.load.image('vialGreenHalf',       'assets/img/vialGreenHalf.png');
            this.game.load.image('vialBlueFull',        'assets/img/vialBlueFull.png');
            this.game.load.image('vialBlueHalf',        'assets/img/vialBlueHalf.png');
            this.game.load.image('vialYellowFull',      'assets/img/vialYellowFull.png');
            this.game.load.image('vialCyanFull',        'assets/img/vialCyanFull.png');
            this.game.load.image('vialMagentaFull',     'assets/img/vialMagentaFull.png');
            this.game.load.image('vialEmpty',           'assets/img/vialEmpty.png');
            this.game.load.image('locker',              'assets/img/locker.png');
            this.game.load.image('lockerOpen',          'assets/img/lockerOpen.png');
            this.game.load.image('room2bg', 'assets/img/room2bg.png');
            
            //Puzzle 1
            this.game.load.image('bottomDrawerClosed',          'assets/img/bottomDrawerClosed.png');
            this.game.load.image('bottomDrawerOpenWithRuby',    'assets/img/bottomDrawerOpenWithRuby.png');
            this.game.load.image('bottomDrawerOpenNoRuby',      'assets/img/bottomDrawerOpenNoRuby.png');
            this.game.load.image('topDrawerClosed',             'assets/img/topDrawerClosed.png');
            this.game.load.image('topDrawerOpenWithPiece',      'assets/img/topDrawerOpenWithPiece.png');
            this.game.load.image('topDrawerOpenNoPiece',        'assets/img/topDrawerOpenNoPiece.png');
            this.game.load.image('skullMissingEye',             'assets/img/skullMissingEye.png');
            this.game.load.image('skullMouthOpenWithKey',       'assets/img/skullMouthOpenWithKey.png');
            this.game.load.image('skullMouthOpenNoKey',         'assets/img/skullMouthOpenNoKey.png');
            this.game.load.image('chest',                       'assets/img/chest.png');
            this.game.load.image('key',                         'assets/img/key.png');
            this.game.load.image('ruby',                        'assets/img/ruby.png');
            this.game.load.image('note',                        'assets/img/note.png');
            this.game.load.image('noteBig',                     'assets/img/noteBig.png');
            this.game.load.image('room1bg',                          'assets/img/room1bg.png');
            
            //Miscelaneous
            this.game.load.image('arrowLeft',           'assets/img/arrowLeft.png');
            this.game.load.image('arrowRight',          'assets/img/arrowRight.png');
            this.game.load.image('arrowDown',           'assets/img/arrowDown.png');
            this.load.image('piece1puzzle64', 'assets/img/piece1puzzle64.png');
            this.load.image('piece2puzzle64', 'assets/img/piece2puzzle64.png');
            this.load.image('piece3puzzle64', 'assets/img/piece3puzzle64.png');
            
            //
            // NOTE: Puzzle5 Assets
            //
            this.game.load.tilemap('puzzle5jsn', 'assets/json/puzzle5.json', null, Phaser.Tilemap.TILED_JSON);
            this.load.image('puzzle5bg', 'assets/img/puzzle5bg.png');
            this.load.image('piece1puzzle', 'assets/img/piece1puzzle.png');
            this.load.image('piece2puzzle', 'assets/img/piece2puzzle.png');
            this.load.image('piece3puzzle', 'assets/img/piece3puzzle.png');
            this.load.image('piece4puzzle', 'assets/img/piece4puzzle.png');
            this.load.image('piece5puzzle', 'assets/img/piece5puzzle.png');
            this.load.image('piece6puzzle', 'assets/img/piece6puzzle.png');
            this.load.image('piece7puzzle', 'assets/img/piece7puzzle.png');
            this.load.image('piece8puzzle', 'assets/img/piece8puzzle.png');
            
            //
            // NOTE: Puzzle4 Assets
            //
            this.game.load.tilemap('puzzle4jsn', 'assets/json/puzzle4.json', null, Phaser.Tilemap.TILED_JSON);
            this.load.image('puzzle4bg', 'assets/img/puzzle4bg.png');
            this.load.image('ubtn', 'assets/img/ubtn.png');
            this.load.image('dbtn', 'assets/img/dbtn.png');
            
            //
            // NOTE: Room 3 - with the snake statue
            //
            this.game.load.tilemap('room3jsn', 'assets/json/room3.json', null, Phaser.Tilemap.TILED_JSON);
            this.load.image('room3bg', 'assets/img/room3bg.png');
            this.load.image('statueClosed', 'assets/img/statueClosed.png');
            this.load.image('statueSolved', 'assets/img/statueSolved.png');
            
            //
            // NOTE: Puzzle3 Assets
            //
            this.game.load.tilemap('puzzle3jsn', 'assets/json/puzzle3.json', null, Phaser.Tilemap.TILED_JSON);
            // this.load.image('puzzle3bg', 'assets/img/puzzle3bg.png');
            this.load.image('statueClosedZoom', 'assets/img/statueClosedZoom.png');
            this.load.image('statueSolvedZoom', 'assets/img/statueSolvedZoom.png');
            
            this.load.onLoadComplete.add( this.startGame, this );
            
            //
            // NOTE: Intro screens
            //
            this.load.image('intro1', 'assets/img/intro1.png');
            this.load.image('intro2', 'assets/img/intro2.png');
            this.load.image('intro3', 'assets/img/intro3.png');
            this.load.image('intro4', 'assets/img/intro4.png');
            this.load.image('intro5', 'assets/img/intro5.png');
            this.load.image('intro6', 'assets/img/intro6.png');
            this.load.image('intro7', 'assets/img/intro7.png');
            this.load.image('intro8', 'assets/img/intro8.png');
            this.load.image('intro9', 'assets/img/intro9.png');
            
            //
            // NOTE: Outro screens
            //
            this.load.image('outro1', 'assets/img/outro1.png');
            this.load.image('outro2', 'assets/img/outro2.png');
            this.load.image('outro3', 'assets/img/outro3.png');
            this.load.image('outro4', 'assets/img/outro4.png');
            this.load.image('outro5', 'assets/img/outro5.png');
            
            //
            // NOTE: Sound Effects and Music
            //
            this.load.audio('drag', 'assets/sfx/drag pieces puzzle.mp3');
            this.load.audio('drawers', 'assets/sfx/drawers.mp3');
            this.load.audio('fillvial', 'assets/sfx/fill vial.mp3');
            this.load.audio('pickvial', 'assets/sfx/pick vial.mp3');
            this.load.audio('success', 'assets/sfx/general-success.mp3');
            this.load.audio('key', 'assets/sfx/key.mp3');
            this.load.audio('openlocker', 'assets/sfx/open locker.mp3');
            this.load.audio('pickpaper', 'assets/sfx/pick paper.mp3');
            this.load.audio('pickruby', 'assets/sfx/ruby.mp3');
            this.load.audio('skullstatue', 'assets/sfx/skull and statue.mp3');
            this.load.audio('unlock', 'assets/sfx/unlock stuff.mp3');
            this.load.audio('offgame', 'assets/music/offgame.mp3');
            this.load.audio('footsteps', 'assets/sfx/footsteps.mp3');
            this.load.audio('scream', 'assets/sfx/scream.mp3');

        }
 
        startGame() {

            // this.game.state.start('Puzzle3', true, false);
            // this.game.state.start('Room1', true, false);
            // this.game.state.start('MainMenu', true, false);
            this.game.add.audio('offgame', 1, true).play();
            this.game.state.start('MainMenu', true, false);

            // this.game.state.start('Intro', true, false);

        }
    }
}